      processor 6502
;Default 2600 Constants set up by dissasembler..
VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
RSYNC   =  $03
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUPF  =  $08
COLUBK  =  $09
CTRLPF  =  $0A
PF0     =  $0D
PF1     =  $0E
PF2     =  $0F
RESP0   =  $10
AUDC0   =  $15
AUDF0   =  $17
AUDV0   =  $19
AUDV1   =  $1A
GRP0    =  $1B
GRP1    =  $1C
ENAM0   =  $1D
ENAM1   =  $1E
ENABL   =  $1F
HMP0    =  $20
VDELP1  =  $26
HMOVE   =  $2A
HMCLR   =  $2B
CXCLR   =  $2C
CXP0FB  =  $32
CXP1FB  =  $33
CXM0FB  =  $34
CXM1FB  =  $35
CXBLPF  =  $36
CXPPMM  =  $37
INPT4   =  $3C
SWCHA   =  $0280
SWCHB   =  $0282
INTIM   =  $0284
TIM64T  =  $0296

ORIGINAL = 0    ; 1 = original code, 0 =  enable my optimizations

       ORG $D000


;Print Display
PrintDisplayX:
       LDA    $1FF9               ;switch banks to go back to the game code              ;4


       STA    HMCLR               ;Clear horzontal motion.                               ;3
       LDA    $86                 ;Position Player00 Sprite To                           ;3
       LDX    #$00                ;      the X Coordinate of Object1.                    ;2
       JSR    PosSpriteX                                                                 ;6
       LDA    $88                 ;Position Player01 Sprite to                           ;3

; the subroutine PosSpriteX doesn't change X, so an increment will do as well
       INX                                                                               ;2
       JSR    PosSpriteX                                                                 ;6
       LDA    $8B                 ;Position Ball Strite to                               ;3
       LDX    #$04                ;      the X Coordinate of the Man.                    ;2
       JSR    PosSpriteX                                                                 ;6
       STA    WSYNC               ;Wait for horizontal Blank.                            ;3
       STA    HMOVE               ;Apply Horizontal Motion.                              ;3
       STA    CXCLR               ;Clear Collision Latches.                              ;3
       LDA    $8C                 ;Get the Y Coordinate of the Man.                      ;3
       SEC                                                                               ;2
       SBC    #$04                ;And Adjust it (By Four Scan Lines)                    ;2
       STA    $8D                 ;      for printing (so Y Coordinate Specifies Middle) ;3

PrintDisplay_1:
; a. after the loop A is 0, so reloading is superflous
; b. replaced A with X so we can increment
; c. bugfix: the register is called VDEL*P*1
       LDX    INTIM               ;Wait for end of the                                   ;4
       BNE    PrintDisplay_1      ;      current fame.                                   ;2
       STX    $90                 ;Set Player00 definition index.                        ;3
       STX    $91                 ;Set Player01 definition index.                        ;3
       STX    $8F                 ;Set room definition index.                            ;3
       STX    GRP1                ;Clear any graphics for Player01.                      ;3
       INX
       STX    VDELP1              ;vertically delay Player 01                            ;3
       LDA    #$68                                                                       ;2
       STA    $8E                 ;Set Scan Lind Count.                                  ;3

;Print top line of Room.
       LDY    $8F                 ;Get room definition index.                            ;3
       LDA    ($80),Y             ;Get first room definition byte.                       ;5
       STA    PF0                 ;      and display.                                    ;3
       INY                                                                               ;2
       LDA    ($80),Y             ;Get Next room definition byte.                        ;5
       STA    PF1                 ;      and display.                                    ;3
       INY                                                                               ;2
       LDA    ($80),Y             ;Get Last room defintion byte.                         ;5
       STA    PF2                 ;      and display.                                    ;3
       INY                                                                               ;2
       STY    $8F                 ;Save for Next Time.                                   ;3
       STA    WSYNC               ;Wait for Horizontal Blank.                            ;3

; a. X still contains 1, so the important bit 1 for VBLANK is zero.
;    (this trick is also very common)
; b. a very usual trick: we know the state of a flag, so we replace JMP with a branch
;    (here Y always != 0 -> Z-flag = 0)
       STX    VBLANK              ;Clear any Vertical Blank.                             ;3
       BNE    PrintPlayer00                                                              ;3

;Print Player01 (Object 02)
PrintPlayer01:
       LDA    $8E                 ;Get Current Scan Line.                                ;3
       SEC                        ;Have we reached Object2's                             ;2
       SBC    $89                 ;      Y Coordinate?                                   ;3
       STA    WSYNC               ;      Wait for Horzonal Blank.                        ;3
       BPL    PrintPlayer00       ;If Not, Branch.                                       ;2
       LDY    $91                 ;Get the Player01 definition index.                    ;3
       LDA    ($84),Y             ;Get the Next Player01 Definition byte                 ;5
       STA    GRP1                ;      and display.                                    ;3
       BEQ    PrintPlayer00       ;If Zero then Definition finished.                     ;2
       INC    $91                 ;Goto next Player01 definition byte.                   ;5

;Print Player00 (Object01), Ball (Man) and Room.
PrintPlayer00:
       LDX    #$00                                                                       ;2
       LDA    $8E                 ;Get the Current Scan Line.                            ;3
       SEC                        ;Have we reached the Object1's                         ;2
       SBC    $87                 ;      Y coordinate?                                   ;3
       BPL    PrintPlayer00_1     ;If not then Branch.                                   ;2
       LDY    $90                 ;Get Player00 definition index.                        ;3
       LDA    ($82),Y             ;Get the Next Player00 definition byte.                ;5
       TAX                                                                               ;2
       BEQ    PrintPlayer00_1     ;If Zero then Definition finished.                     ;2
       INC    $90                 ;Go to Next Player00 definition byte.                  ;5

PrintPlayer00_1:
       LDY    #$00                ;Disable Ball Graphic.                                 ;2
       LDA    $8E                 ;Get Scan line count.                                  ;3
       SEC                        ;Have we reached the Man's                             ;2
       SBC    $8D                 ;      Y Coordinate?                                   ;3
       AND    #$FC                ;Mask value to four either side (getting depth of 8)   ;2
       BNE    PrintPlayer00_2     ;If Not, Branch.                                       ;2
       LDY    #$02                ;Enable Ball Graphic.                                  ;2

PrintPlayer00_2:
       LDA    $8E                 ;Get Scan Line Count.                                  ;3


       AND    #$0F                ;Have we reached a sixteenth scan line?                ;2

;NOTE! The above line could be changed to 7 (checking every 8th scanline instead).  This will
;effectively DOUBLE the resolution for each screen. (you'll need to update the room GFX tables
;to have 42 bytes instead of 21).  The upper and lower lines of the higher res. bitmaps will
;just *barely* be visible...so by clever placement of the tags, this could be reduced to 36
;bytes per screen :)  Format of the updated line would be this:
;;       AND    #$07                ;Have we reached a eighth scan line?                   ;2
;...that will replace the above line and the program will grab new GFX values on every 8th line


       BNE    PrintPlayer00_4     ;If not, Branch.                                       ;2
       STA    WSYNC               ;Wait for Horzontal Blank.                             ;3
       STY    ENABL               ;Enable Ball (If Wanted)                               ;3
       STX    GRP0                ;Display Player 00 definition byte (if wanted)         ;3
       LDY    $8F                 ;Get room definition index.                            ;3
       LDA    ($80),Y             ;Get first room definition byte,                       ;5
       STA    PF0                 ;      and display.                                    ;3
       INY                                                                               ;2
       LDA    ($80),Y             ;Get next room definition byte,                        ;5
       STA    PF1                 ;      and display.                                    ;3
       INY                                                                               ;2
       LDA    ($80),Y             ;Get next room definition byte,                        ;5
       STA    PF2                 ;      and display.                                    ;3
       INY                                                                               ;2
       STY    $8F                 ;Save for Next Time.                                   ;3

PrintPlayer00_3:
       DEC    $8E                 ;Goto next scan line.                                  ;5
       LDA    $8E                 ;Get the scan line.                                    ;3
       CMP    #$08                ;Have we reached to within 8 scanlines of the bottom?  ;2
       BPL    PrintPlayer01       ;If not, Branch.                                       ;2
       STA    VBLANK              ;Turn on VBLANK                                        ;3
;Tidy Up
TidyUp:
       LDA    #$00                                                                       ;2
       STA    GRP1                ;Clear any graphics for Player01                       ;3
       STA    GRP0                ;Clear any graphics for Player00                       ;3
       LDA    #$20                                                                       ;2
       STA    TIM64T              ;Stat Timing this frame using                          ;4
       JMP    PrintDisplayX       ;                                                      ;3

  IF ORIGINAL = 0
; a. by reordering the code, we avoid the jump to TidyUp
; b. again used the branch trick
PrintPlayer00_4:
       STA    WSYNC               ;Wait for Horzontal blank.                             ;3
       STY    ENABL               ;Enable Ball (If Wanted.)                              ;3
       STX    GRP0                ;Display Player00 definition byte (if Wanted).         ;3
       BNE    PrintPlayer00_3                                                            ;3
; 4 bytes saved
  ENDIF

;Position Sprite X horizontally.
PosSpriteX:
       LDY    #$02                ;Start with 10 clock cycles (to avoid HBLANK)          ;2
       SEC                        ;Divide the Coordinate.                                ;2

PosSpriteX_1:
       INY                        ;      Wanted by Fifteen I.E.                          ;2
       SBC    #$0F                ;      Get Course Horizontal                           ;2
       BCS    PosSpriteX_1        ;      Value (In Multiples of 5 Clock Cycles           ;2
                                  ;      (Therefore giving 15 Color Cycles)
       EOR    #$FF                ;Flip remanter to positive value (inverted).           ;2
       SBC    #$06                ;Convert to left or right of current position.         ;2
       ASL                                                                               ;2
       ASL                        ;Move to high nybble for TIA                           ;2
       ASL                        ;      horizontal motion.                              ;2
       ASL                                                                               ;2
       STY    WSYNC               ;Wait for horozontal blank.                            ;3

PosSpriteX_2:
       DEY                        ;Count down the color                                  ;2
       BPL    PosSpriteX_2        ;      cycles (these are 5 machine/15 color cycles).   ;2
       STA    RESP0,X             ;Reset the sprite, thus positioning it coursely.       ;4
       STA    HMP0,X              ;Set horizontal (fine) motion of sprite.               ;4
       RTS                                                                               ;6


       ORG $D100

;----------------------end of subroutine...rest of bank can be devoted to GFX :)------------














       ORG $D914

;Object #9 : State FF : Graphics
GfxSword:
       .byte $20                  ;  X
       .byte $40                  ; X
       .byte $FF                  ;XXXXXXXX
       .byte $40                  ; X
       .byte $20                  ;  X
       .byte $00

;Object #0E : State 03 : Graphic
GfxBat1:
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $FF                  ;XXXXXXXX
       .byte $5A                  ; X XX X
       .byte $66                  ; XX  XX
       .byte $00
;Object #0E : State FF : Graphic
GfxBat2:
       .byte $01                  ;       X
       .byte $80                  ;X
       .byte $01                  ;       X
       .byte $80                  ;X
       .byte $3C                  ;  XXXX
       .byte $5A                  ; X XX X
       .byte $66                  ; XX  XX
       .byte $C3                  ;XX    XX
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $00


;Below Yellow Castle
BelowYellowCastle:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR

;Below Yellow Castle2
BelowYellowCastle2:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR

;Left of Name Room
LeftOfName:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Top of Blue Maze
BlueMazeTop:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$0C,$0C          ;        XX    XX        RR    RR
       .byte $F0,$0C,$3C          ;XXXX    XX    XXXX    RRRR    RR    RRRR
       .byte $F0,$0C,$00          ;XXXX    XX                    RR    RRRR
       .byte $F0,$FF,$3F          ;XXXXXXXXXXXXXXXXXX    RRRRRRRRRRRRRRRRRR
       .byte $00,$30,$30          ;      XX        XX    RR        RR
       .byte $F0,$33,$3F          ;XXXX  XX  XXXXXXXX    RRRRRRRR  RR  RRRR

;Blue Maze #1
BlueMaze1:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $00,$00,$00          ;
       .byte $F0,$FC,$FF          ;XXXXXXXXXX  XXXXXXXXRRRRRRRR  RRRRRRRRRR
       .byte $F0,$00,$C0          ;XXXX              XXRR              RRRR
       .byte $F0,$3F,$CF          ;XXXX  XXXXXXXXXX  XXRR  RRRRRRRRRR  RRRR
       .byte $00,$30,$CC          ;      XX      XX  XXRR  RR      RR
       .byte $F0,$F3,$CC          ;XXXXXXXX  XX  XX  XXRR  RR  RR  RRRRRRRR

;Bottom of Blue Maze
BlueMazeBottom:
       .byte $F0,$F3,$0C          ;XXXXXXXX  XX  XX        RR  RR  RRRRRRRR
       .byte $00,$30,$0C          ;      XX      XX        RR      RR
       .byte $F0,$3F,$0F          ;XXXX  XXXXXXXXXX        RRRRRRRRRR  RRRR
       .byte $F0,$00,$00          ;XXXX                                RRRR
       .byte $F0,$F0,$00          ;XXXXXXXX                        RRRRRRRR
       .byte $00,$30,$00          ;      XX                        RR
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR

;Center of Blue Maze
BlueMazeCenter:
       .byte $F0,$33,$3F          ;XXXX  XX  XXXXXXXX    RRRRRRRR  RR  RRRR
       .byte $00,$30,$3C          ;      XX      XXXX    RRRR      RR
       .byte $F0,$FF,$3C          ;XXXXXXXXXXXX  XXXX    RRRR  RRRRRRRRRRRR
       .byte $00,$03,$3C          ;          XX  XXXX    RRRR  RR
       .byte $F0,$33,$3C          ;XXXX  XX  XX  XXXX    RRRR  RR  RR  RRRR
       .byte $00,$33,$0C          ;      XX  XX  XX        RR  RR  RR
       .byte $F0,$F3,$0C          ;XXXXXXXX  XX  XX        RR  RR  RRRRRRRR

;Blue Maze Entry
BlueMazeEntry:
       .byte $F0,$F3,$CC          ;XXXXXXXX  XX  XX  XXRR  RR  RR  RRRRRRRR
       .byte $00,$33,$0C          ;      XX  XX  XX        RR  RR  RR
       .byte $F0,$33,$FC          ;XXXX  XX  XX  XXXXXXRRRRRR  RR  RR  RRRR
       .byte $00,$33,$00          ;      XX  XX                RR  RR
       .byte $F0,$F3,$FF          ;XXXXXXXX  XXXXXXXXXXRRRRRRRRRR  RRRRRRRR
       .byte $00,$00,$00          ;
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Maze Middle
MazeMiddle:
       .byte $F0,$FF,$CC          ;XXXXXXXXXXXX  XX  XXRR  RR  RRRRRRRRRRRR
       .byte $00,$00,$CC          ;              XX  XXRR  RR
       .byte $F0,$03,$CF          ;XXXX      XXXXXX  XXRR  RRRRRR      RRRR
       .byte $00,$03,$00          ;          XX                RR
       .byte $F0,$F3,$FC          ;XXXXXXXX  XX  XXXXXXRRRRRR  RR  RRRRRRRR
       .byte $00,$33,$0C          ;      XX  XX  XX        RR  RR  RR
       .byte $F0,$33,$CC          ;XXXX  XX  XX  XX  XXRR  RR  RR  RR  RRRR

;Maze Entry
MazeEntry:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$30,$00          ;      XX                        RR
       .byte $F0,$30,$FF          ;XXXX  XX    XXXXXXXXRRRRRRRRR   RR  RRRR
       .byte $00,$30,$C0          ;      XX          XXRR          RR
       .byte $F0,$F3,$C0          ;XXXXXXXX  XX      XXRR      RR  RRRRRRRR
       .byte $00,$03,$C0          ;          XX      XXRR      RR
       .byte $F0,$FF,$CC          ;XXXXXXXXXXXX  XX  XXRR  RR  RRRRRRRRRRRR


       ORG $DA00

;Maze Side
MazeSide:
       .byte $F0,$33,$CC          ;XXXX  XX  XX  XX  XXRR  RR  RR  RR  RRRR
       .byte $00,$30,$CC          ;      XX      XX  XXRR  RR      RR
       .byte $00,$3F,$CF          ;      XXXXXX  XX  XXRR  RR  RRRRRR
       .byte $00,$00,$C0          ;                  XXRR
       .byte $00,$3F,$C3          ;      XXXXXXXX    XXRR    RRRRRRRR
       .byte $00,$30,$C0          ;      XX          XXRR          RR
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR

;Side Corridor
SideCorridor:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Side Corridor2
SideCorridor2:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Top Entry Room
TopEntryRoom:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXMMMMMMMMMMMMMMMMMMMM

;Castle Definition
CastleDef:
       .byte $F0,$FE,$15          ;XXXXXXXXXXX X X X      R R R RRRRRRRRRRR
       .byte $30,$03,$1F          ;XX        XXXXXXX      RRRRRRR        RR
       .byte $30,$03,$FF          ;XX        XXXXXXXXXXRRRRRRRRRR        RR
       .byte $30,$00,$FF          ;XX          XXXXXXXXRRRRRRRR          RR
       .byte $30,$00,$3F          ;XX          XXXXXX    RRRRRR          RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXX            RRRRRRRRRRRRRR

;Number Room2 Definition
NumberRoom2:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Black Maze #1
BlackMaze1:
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXRRRRRRRR    RRRRRRRR
       .byte $00,$00,$03          ;            XX            RR
       .byte $F0,$FF,$03          ;XXXXXXXXXXXXXX            RRRRRRRRRRRRRR
       .byte $00,$00,$00          ;
       .byte $30,$3F,$FF          ;XX    XXXXXXXXXXXXXXRRRRRRRRRRRRRR    RR
       .byte $00,$30,$00          ;      XX                        RR
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXRRRRRRRR    RRRRRRRR

;Black Maze #2
BlackMaze2:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXMMMMMMMMMMMMMMMMMMMM
       .byte $00,$00,$C0          ;                  XX                  MM
       .byte $F0,$FF,$CF          ;XXXXXXXXXXXXXXXX  XXMMMMMMMMMMMMMMMM  MM
       .byte $00,$00,$0C          ;                  XX                  MM
       .byte $F0,$0F,$FF          ;XXXX    XXXXXXXXXXXXMMMM    MMMMMMMMMMMM
       .byte $00,$0F,$C0          ;        XXXX      XX        MMMM      MM
       .byte $30,$CF,$CC          ;XX  XX  XXXX  XX  XXMM  MM  MMMM  MM  MM

;Black Maze #3
BlackMaze3:
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXRRRRRRRR    RRRRRRRR
       .byte $30,$00,$00          ;XX                  MM
       .byte $30,$3F,$FF          ;XX    XXXXXXXXXXXXXXMM    MMMMMMMMMMMMMM
       .byte $00,$30,$00          ;      XX                  MM
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXMMMMMMMM    MMMMMMMM
       .byte $30,$00,$03          ;XX          XX      MM          MM
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXMMMMMMMM    MMMMMMMM

;Black Maze Entry
BlackMazeEntry:
       .byte $30,$CF,$CC          ;XX  XX  XXXX  XX  XXMM  MM  MMMM  MM  MM
       .byte $00,$C0,$CC          ;    XX        XX  XXRR  RR        RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00          ;
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00          ;
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Red Maze #1
RedMaze1:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $00,$00,$00          ;
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$0C          ;                  XX        RR
       .byte $F0,$FF,$0C          ;XXXXXXXXXXXX  XX        RR  RRRRRRRRRRRR
       .byte $F0,$03,$CC          ;XXXX      XX  XX  XXRR  RR  RR      RRRR
       .byte $F0,$33,$CF          ;XXXX  XX  XXXXXX  XXRR  RRRRRR  RR  RRRR


;Object #0A : State FF : Graphic
GfxBridge:
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $00

       ORG $DB00

;Top of Red Maze
RedMazeTop:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $00,$00,$C0          ;                  XXRR
       .byte $F0,$FF,$CF          ;XXXXXXXXXXXXXXXX  XXRR  RRRRRRRRRRRRRRRR
       .byte $00,$00,$CC          ;              XX  XXRR  RR
       .byte $F0,$33,$FF          ;XXXX  XX  XXXXXXXXXXRRRRRRRRRR  RR  RRRR
       .byte $F0,$33,$00          ;XXXX  XX  XX                RR  RR  RRRR
       .byte $F0,$3F,$0C          ;XXXX  XXXXXX  XX        RR  RRRRRR  RRRR

;Bottom of Red Maze
RedMazeBottom:
       .byte $F0,$33,$CF          ;XXXX  XX  XXXXXX  XXRR  RRRRRR  RR  RRRR
       .byte $F0,$30,$00          ;XXXX  XX                        RR  RRRR
       .byte $F0,$33,$FF          ;XXXX  XX  XXXXXXXXXXRRRRRRRRRR  RR  RRRR
       .byte $00,$33,$00          ;      XX  XX                RR  RR  RRRR
       .byte $F0,$FF,$00          ;XXXXXXXXXXXX                RRRRRRRRRRRR
       .byte $00,$00,$00          ;
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;White Castle Entry
WhiteCastleEntry:
       .byte $F0,$3F,$0C          ;XXXX  XXXXXX  XX        RR  RRRRRR  RRRR
       .byte $F0,$00,$0C          ;XXXX          XX        RR          RRRR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$30,$00          ;      XX                        RR
       .byte $F0,$30,$00          ;XXXX  XX                        RR  RRRR
       .byte $00,$30,$00          ;      XX                        RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Two Exit Room
TwoExitRoom:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Number Room3 Definition
NumberRoom3:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Top Entry Room2
TopEntryRoom2:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXMMMMMMMMMMMMMMMMMMMM

;Below Yellow Castle3
BelowYellowCastle3:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $00,$00,$00
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR

CustomRoom1:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

CustomRoom2:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

CustomRoom3:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

CustomRoom4:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Object #1 States 940FF (Graphic)
GfxPort01:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort02:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort03:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort04:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort05:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort06:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort07:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort08:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort09:
GfxNull:
       .byte $00                  ;


;spare
       .byte $00                  ;
       .byte $00                  ;
       .byte $00                  ;
       .byte $00                  ;
       .byte $00                  ;
       .byte $00                  ;
       .byte $00                  ;
       .byte $00                  ;


       ORG $DC00

CustomRoom5:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Number Room Definition
NumberRoom:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR




;Object #1 : Graphic
GfxSurround:
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $00

;Object #11 : State FF : Graphic
GfxMagnet:
       .byte $3C                  ;  XXXX
       .byte $7E                  ; XXXXXX
       .byte $E7                  ;XXX  XXX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $00

;Object #0B : State FF : Graphic
GfxKey:
       .byte $07                  ;     XXX
       .byte $FD                  ;XXXXXX X
       .byte $A7                  ;X X  XXX
       .byte $00



;Object #6 : State #00 : Graphic
GfxDrag0:
       .byte $06                  ;     XX
       .byte $0F                  ;    XXXX
       .byte $F3                  ;XXXX  XX
       .byte $FE                  ;XXXXXXX
       .byte $0E                  ;    XXX
       .byte $04                  ;     X
       .byte $04                  ;     X
       .byte $1E                  ;   XXXX
       .byte $3F                  ;  XXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $E3                  ;XXX   XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C7                  ;XX   XXX
       .byte $FF                  ;XXXXXXXX
       .byte $3C                  ;  XXXX
       .byte $08                  ;    X
       .byte $8F                  ;X   XXXX
       .byte $E1                  ;XXX    X
       .byte $3F                  ;  XXXXXX
       .byte $00

;Object 6 : State FF : Graphic
GfxDrag1:
       .byte $80                  ;X
       .byte $40                  ; X
       .byte $26                  ;  X  XX
       .byte $1F                  ;   XXXXX
       .byte $0B                  ;    X XX
       .byte $0E                  ;    XXX
       .byte $1E                  ;   XXXX
       .byte $24                  ;  X  X
       .byte $44                  ; X   X
       .byte $8E                  ;X   XXX
       .byte $1E                  ;   XXXX
       .byte $3F                  ;  XXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $3E                  ;  XXXXX
       .byte $1C                  ;   XXX
       .byte $08                  ;    X
       .byte $F8                  ;XXXXX
       .byte $80                  ;X
       .byte $E0                  ;XXX
       .byte $00

;Object 6 : State 02 : Graphic
GfxDrag2:
       .byte $0C                  ;    XX
       .byte $0C                  ;    XX
       .byte $0C                  ;    XX
       .byte $0E                  ;    XXX
       .byte $1B                  ;   XX X
       .byte $7F                  ; XXXXXXX
       .byte $CE                  ;XX  XXX
       .byte $80                  ;X
       .byte $FC                  ;XXXXXX
       .byte $FE                  ;XXXXXXX
       .byte $FE                  ;XXXXXXX
       .byte $7E                  ; XXXXXX
       .byte $78                  ; XXXX
       .byte $20                  ;  X
       .byte $6E                  ; XX XXX
       .byte $42                  ; X    X
       .byte $7E                  ; XXXXXX
       .byte $00

;Object #10 : State FF : Graphic
GfxChallise:
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $C3                  ;XX    XX
       .byte $7E                  ; XXXXXX
       .byte $7E                  ; XXXXXX
       .byte $3C                  ;  XXXX
       .byte $18                  ;   XX
       .byte $18                  ;   XX
       .byte $7E                  ; XXXXXX
       .byte $00

       ORG $DD00


;Object #5 State #1 Graphic :'1'
GfxNum1:
       .byte $04                  ; X
       .byte $0C                  ;XX
       .byte $04                  ; X
       .byte $04                  ; X
       .byte $04                  ; X
       .byte $04                  ; X
       .byte $0E                  ;XXX
       .byte $00

;Object #5 State #2 Grphic : '2'
GfxNum2:
       .byte $0E                  ; XXX
       .byte $11                  ;X   X
       .byte $01                  ;    X
       .byte $02                  ;   X
       .byte $04                  ;  X
       .byte $08                  ; X
       .byte $1F                  ;XXXXX
       .byte $00

;Object #5 State #3 Graphic :'3'
GfxNum3:
       .byte $0E                  ; XXX
       .byte $11                  ;X   X
       .byte $01                  ;    X
       .byte $06                  ;  XX
       .byte $01                  ;    X
       .byte $11                  ;X   X
       .byte $0E                  ; XXX
       .byte $00

;Object #0F : State FF : Graphic
GfxDot:
       .byte $80                  ;X
       .byte $00


  ORG $df00

;Object #4 : State FF : Graphic
GfxAuthor:
       .byte $F0                  ;XXXX
       .byte $80                  ;X
       .byte $80                  ;X
       .byte $80                  ;X
       .byte $F4                  ;XXXX X
       .byte $04                  ;     X
       .byte $87                  ;X    XXX
       .byte $E5                  ;XXX  X X
       .byte $87                  ;X    XXX
       .byte $80                  ;X
       .byte $05                  ;     X X
       .byte $E5                  ;XXX  X X
       .byte $A7                  ;X X  XXX
       .byte $E1                  ;XXX    X
       .byte $87                  ;X    XXX
       .byte $E0                  ;XXX
       .byte $01                  ;       X
       .byte $E0                  ;XXX
       .byte $A0                  ;X X
       .byte $F0                  ;XXXX
       .byte $01                  ;       X
       .byte $40                  ; X
       .byte $E0                  ;XXX
       .byte $40                  ; X
       .byte $40                  ; X
       .byte $40                  ; X
       .byte $01                  ;       X
       .byte $E0                  ;XXX
       .byte $A0                  ;X X
       .byte $E0                  ;XXX
       .byte $80                  ;X
       .byte $E0                  ;XXX
       .byte $01                  ;       X
       .byte $20                  ;  X
       .byte $20                  ;  X
       .byte $E0                  ;XXX
       .byte $A0                  ;X X
       .byte $E0                  ;XXX
       .byte $01                  ;       X
       .byte $01                  ;       X
       .byte $01                  ;       X
       .byte $11                  ;   X   X
       .byte $A8                  ;X X X
       .byte $A8                  ;X X X
       .byte $A8                  ;X X X
       .byte $F8                  ;XXXXX
       .byte $01                  ;       X
       .byte $E0                  ;XXX
       .byte $A0                  ;X X
       .byte $F0                  ;XXXX
       .byte $01                  ;       X
       .byte $80                  ;X
       .byte $E0                  ;XXX
       .byte $8F                  ;X   XXXX
       .byte $89                  ;X   X  X
       .byte $0F                  ;    XXXX
       .byte $8A                  ;X   X X
       .byte $E9                  ;XXX X  X
       .byte $80                  ;X
       .byte $8E                  ;X   XXX
       .byte $0A                  ;    X X
       .byte $EE                  ;XXX XXX
       .byte $A0                  ;X X
       .byte $E8                  ;XXX X
       .byte $88                  ;X   X
       .byte $EE                  ;XXX XXX
       .byte $0A                  ;    X X
       .byte $8E                  ;X   XXX
       .byte $E0                  ;XXX
       .byte $A4                  ;X X  X
       .byte $A4                  ;X X  X
       .byte $04                  ;     X
       .byte $80                  ;X
       .byte $08                  ;    X
       .byte $0E                  ;    XXX
       .byte $0A                  ;    X X
       .byte $0A                  ;    X X
       .byte $80                  ;X
       .byte $0E                  ;    XXX
       .byte $0A                  ;    X X
       .byte $0E                  ;    XXX
       .byte $08                  ;    X
       .byte $0E                  ;    XXX
       .byte $80                  ;X
       .byte $04                  ;     X
       .byte $0E                  ;    XXX
       .byte $04                  ;     X
       .byte $04                  ;     X
       .byte $04                  ;     X
       .byte $80                  ;X
       .byte $04                  ;     X
       .byte $0E                  ;    XXX
       .byte $04                  ;     X
       .byte $04                  ;     X
       .byte $04                  ;     X
       .byte $00


  ORG $dff8

;6502 Vectors...leave unchanged for this bank

       .byte $FF
       .byte $FF
       .byte $FF
       .byte $FF
       .byte $FF
       .byte $FF
       .byte $FF
       .byte $FF
