;GFX info transferred after compiling bank1 (use the -s tag and paste the info from the text)

;----------------------------------------------------------

BlueMazeCenter  = $d9ac    
GfxPort01       = $dbe7    
GfxPort02       = $dbe9    
GfxPort03       = $dbeb    
GfxPort04       = $dbed    
GfxPort05       = $dbef    
GfxPort06       = $dbf1    
GfxPort07       = $dbf3    
GfxPort08       = $dbf5    
GfxChallise     = $dc96    
GfxPort09       = $dbf7    
WhiteCastleEntry = $db2a    
BlackMazeEntry  = $dabd    
MazeEntry       = $d9eb    
BlueMazeEntry   = $d9c1    
RedMazeBottom   = $db15    
BlueMazeBottom  = $d997    
CastleDef       = $da54    
GfxNull         = $dbf7    
GfxNum1         = $dd00    
GfxNum2         = $dd08    
GfxNum3         = $dd10    
GfxKey          = $dc54    
BelowYellowCastle2 = $d943    
BelowYellowCastle3 = $db7e    
GfxDot          = $dd18    
GfxSword        = $d914    
NumberRoom      = $dc15    
LeftOfName      = $d958    
TopEntryRoom    = $da3f    
MazeSide        = $da00    
CustomRoom4     = $dbd2    
CustomRoom5     = $dc00    
CustomRoom1     = $db93    
CustomRoom2     = $dba8    
TopEntryRoom2   = $db69    
NumberRoom2     = $da69    
CustomRoom3     = $dbbd    
NumberRoom3     = $db54    
SideCorridor2   = $da2a    
GfxDrag0        = $dc58    
GfxDrag1        = $dc6d    
GfxDrag2        = $dc84    
RedMaze1        = $dad2    
BlackMaze1      = $da7e    
BlueMaze1       = $d982    
BlackMaze2      = $da93    
BlackMaze3      = $daa8    
GfxSurround     = $dc2a    
GfxAuthor       = $df00    
BelowYellowCastle = $d92e    
GfxBat1         = $d91a    
GfxBat2         = $d922    
MazeMiddle      = $d9d6    
TwoExitRoom     = $db3f    
GfxMagnet       = $dc4b    
RedMazeTop      = $db00    
BlueMazeTop     = $d96d    
SideCorridor    = $da15    
GfxBridge       = $dae7    

;----------------------------------------------------------

      processor 6502
;Default 2600 Constants set up by dissasembler..
VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
RSYNC   =  $03
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUPF  =  $08
COLUBK  =  $09
CTRLPF  =  $0A
PF0     =  $0D
PF1     =  $0E
PF2     =  $0F
RESP0   =  $10
AUDC0   =  $15
AUDF0   =  $17
AUDV0   =  $19
AUDV1   =  $1A
GRP0    =  $1B
GRP1    =  $1C
ENAM0   =  $1D
ENAM1   =  $1E
ENABL   =  $1F
HMP0    =  $20
VDELP1  =  $26
HMOVE   =  $2A
HMCLR   =  $2B
CXCLR   =  $2C
CXP0FB  =  $32
CXP1FB  =  $33
CXM0FB  =  $34
CXM1FB  =  $35
CXBLPF  =  $36
CXPPMM  =  $37
INPT4   =  $3C
SWCHA   =  $0280
SWCHB   =  $0282
INTIM   =  $0284
TIM64T  =  $0296

ORIGINAL = 0    ; 1 = original code, 0 =  enable my optimizations

       ORG $F000

PrintDisplay:
       LDA    $1FF8                                                              ;4 call bank 1
       RTS                                                                       ;6 return

;Position Sprite X horizontally.
PosSpriteX:
       LDY    #$02                ;Start with 10 clock cycles (to avoid HBLANK)  ;2
       SEC                        ;Divide the Coordinate.                        ;2

PosSpriteX_1:
       INY                        ;      Wanted by Fifteen I.E.                  ;2
       SBC    #$0F                ;      Get Course Horizontal                   ;2
       BCS    PosSpriteX_1        ;      Value (In Multiples of 5 Clock Cycles   ;2
                                  ;      (Therefore giving 15 Color Cycles)
       EOR    #$FF                ;Flip remanter to positive value (inverted).   ;2
       SBC    #$06                ;Convert to left or right of current position. ;2
       ASL                                                                       ;2
       ASL                        ;Move to high nybble for TIA                   ;2
       ASL                        ;      horizontal motion.                      ;2
       ASL                                                                       ;2
       STY    WSYNC               ;Wait for horozontal blank.                    ;3

PosSpriteX_2:
       DEY                        ;Count down the color                          ;2
       BPL    PosSpriteX_2        ;cycles (these are 5 machine/15 color cycles). ;2
       STA    RESP0,X             ;Reset the sprite, thus positioning it coursely;4
       STA    HMP0,X              ;Set horizontal (fine) motion of sprite.       ;4
       RTS                                                                       ;6

;Preform VSYNC
DoVSYNC:
       LDX    INTIM               ;Get Timer Output                              ;4
       BNE    DoVSYNC             ;Wait for Time-Out                             ;2
       LDA    #$02                                                               ;2
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    VBLANK              ;Start Vertical Blanking.                      ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    VSYNC               ;Start verticle sync.                          ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STX    VSYNC               ;End Vertical sync.                            ;3
       LDA    #$2A                ;Set clock interval to                         ;2
       STA    TIM64T              ;Countdown next frame.                         ;4
       RTS                                                                       ;6

;Setup a room for print.
SetupRoomPrint:
       LDA    $8A                 ;Get current room number.                      ;3
       JSR    RoomNumToAddress    ;Convert it to an address.                     ;6
       LDY    #$00                                                               ;2
       LDA    ($93),Y             ;Get low pointer to room                       ;5
       STA    $80                 ;      Graphics                                ;3
       INY                                                                       ;2
       LDA    ($93),Y             ;Get high pointer to room                      ;5
       STA    $81                 ;      Graphics                                ;3

;Use Color
       INY                                                                       ;2
       LDA    ($93),Y             ;Get room color                                ;5
       JSR    ChangeColor         ;Change if necessary                           ;6
       STA    COLUPF              ;Put in Playfiled color register.              ;3

;Color Background.
UseColor:
       LDA    #$08                ;Get light grey background                     ;2
       JSR    ChangeColor         ;Change if necessary                           ;6
       STA    COLUBK              ;Put it in the Background color register.      ;3

;Playfield Control.
       LDY    #$03                                                               ;2
       LDA    ($93),Y             ;Get the playfield control value.              ;5
       STA    CTRLPF              ;And put in the playfield control register.    ;3
       LSR                                                                       ;2
       LSR                                                                       ;2
       LSR                        ;Get the first bit into position.              ;2
       LSR                                                                       ;2
       LSR                                                                       ;2
       STA    ENAM1               ;Enable right hand wall (if wanted-missile01)  ;3
       LSR                                                                       ;2
       STA    ENAM0               ;Enable left hand wall(if wanted-missle00)     ;3

;Get objects to display.
       JSR    CacheObjects        ;Get next two objects to display.              ;6

;Sort out their order.
       LDA    $95                 ;If the object1 is the                         ;3
       BEQ    SwapPrintObjects    ;Then branch to swap (we want it as player01)  ;2
       CMP    #$50                ;If the first object is the bridge then        ;2
       BNE    SetupObjectPrint    ;Swap the objects (we want it as player01)     ;2
       LDA    $96                 ;If the object2 is the                         ;3
       BEQ    SetupObjectPrint    ;it (we want it as player01)                   ;2

SwapPrintObjects:
; using an unused register for swapping makes the code much shorter
       LDA    $95                                                                ;3
       LDX    $96                                                                ;3
       STA    $96                 ;Swap the objects to print.                    ;3
       STX    $95                                                                ;3

;Setup Object1 to print.
SetupObjectPrint:
       LDX    $95                 ;Get Object1                                   ;3
       LDA    Store1,X            ;Get low pointer to it's dynamic information.  ;4
       STA    $93                                                                ;3
       LDA    Store2,X            ;Get high pointer to it's dynamic informtion.  ;4
       STA    $94                                                                ;3
       LDY    #$01                                                               ;2
       LDA    ($93),Y             ;Get Object1's X coordinate                    ;5
       STA    $86                 ;and Store for print.                          ;3
       INY                                                                       ;2
       LDA    ($93),Y             ;Get Object1's Y coordinate                    ;5
       STA    $87                 ;and Store for print.                          ;3
       LDA    Store3,X            ;Get low pointer to state value.               ;4
       STA    $93                                                                ;3
       LDA    Store4,X            ;Get high pointer to state value.              ;4
       STA    $94                                                                ;3
       LDY    #$00                                                               ;2
       LDA    ($93),Y             ;Retrieve Object1's current state.             ;5
       STA    $DC                                                                ;3
       LDA    Store5,X            ;Get low pointer to state information.         ;4
       STA    $93                                                                ;3
       LDA    Store6,X            ;Get high pointer to state information.        ;4
       STA    $94                                                                ;3
       JSR    GetObjectState      ;Find current state in the state information.  ;6
       INY                        ;Index to the state's corresponding graphic pointer;2
       LDA    ($93),Y             ;Get Object1's low graphic address             ;5
       STA    $82                 ;and store for print.                          ;3
       INY                                                                       ;2
       LDA    ($93),Y             ;Get Object1's high graphic address            ;5
       STA    $83                 ;and store for print.                          ;3

;Colour
       LDA    Store7,X             ;Get Object1's Color.                         ;4
       JSR    ChangeColor         ;Change if necessary.                          ;6
       STA    COLUP0              ;And set color luminance00.                    ;3
       JMP    ResizeObject                                                       ;3

;Object1 Size
ResizeObject:
       LDA    Store8,X             ;Get Object1's Size                           ;4
       ORA    #$10                ;And set to larger size if necessary.          ;2
       STA    NUSIZ0              ;(Used by bridge and invisible surround)       ;3

;Setup Object 2 to Print.
       LDX    $96                 ;Get Object 2                                  ;3
       LDA    Store1,X                                                           ;4
       STA    $93                 ;Get low pointer to it's dynamic information.  ;3
       LDA    Store2,X                                                           ;4
       STA    $94                 ;Get high pointer to it's dynamic information. ;3
       LDY    #$01                                                               ;2
       LDA    ($93),Y             ;Get Object2's X coordinate                    ;5
       STA    $88                 ;and store for print.                          ;3
       INY                        ;                                              ;2
       LDA    ($93),Y             ;Get Object2's Y coordinate                    ;5
       STA    $89                 ;and store for print.                          ;3
       LDA    Store3,X             ;Get low pointer to state value.              ;4
       STA    $93                                                                ;3
       LDA    Store4,X             ;Get high pointer to state value.             ;4
       STA    $94                                                                ;3
       LDY    #$00                                                               ;2
       LDA    ($93),Y             ;Retrieve Object2's current state.             ;5
       STA    $DC                                                                ;3
       LDA    Store5,X             ;Get low pointer to state information.        ;4
       STA    $93                                                                ;3
       LDA    Store6,X             ;Get high pointer to state information.       ;4
       STA    $94                                                                ;3
       JSR    GetObjectState      ;Find the current state in the state information;6
       INY                        ;Index to the state's corresponding graphic pointer;2
       LDA    ($93),Y                                                            ;5
       STA    $84                 ;Get Object2's low graphic address.            ;3
       INY                                                                       ;2
       LDA    ($93),Y             ;Get Object2's high graphic address.           ;5
       STA    $85                                                                ;3

;Color
       LDA    Store7,X             ;Get Object2;s Color                          ;4
       JSR    ChangeColor         ;Change if Necessary.                          ;6
       STA    COLUP1              ;and set color luminance01.                    ;3
       JMP    ResizeObject2                                                      ;3

;Object2 Size
ResizeObject2:
       LDA    Store8,X             ;Get Object2's Size                           ;4
       ORA    #$10                ;And set to larger size if necessary.          ;2
       STA    NUSIZ1              ;(Used by bridge and invisible surround)       ;3
       RTS                                                                       ;6

;Fill cache with two objects in this room.
CacheObjects:
       LDY    $9C                 ;Get Last Object                               ;3
       LDA    #$90                ;Set cache to (Num Is (8 * NumOfObj) - 8)      ;2
       STA    $95                 ;      no-ojects.                              ;3
       STA    $96                                                                ;3

MoveNextObject:
       TYA                                                                       ;2
       CLC                        ;Goto the next object to                       ;2
       ADC    #$08                ;check (add nine).                             ;2
       CMP    #$90                ;Check if over maximum.(Num Is (8*NumOfObj)-8) ;2
       BCC    GetObjectsInfo                                                     ;2
       LDA    #$00                ;If so, wrap to zero.                          ;2

GetObjectsInfo:
       TAY                                                                       ;2
       LDA    Store1,Y             ;Get low byte of object info.                 ;4
       STA    $93                                                                ;3
       LDA    Store2,Y             ;Get high byte of object info.                ;4
       STA    $94                                                                ;3
       LDX    #$00                                                               ;2
       LDA    ($93,X)             ;Get objects current room.                     ;6
       CMP    $8A                 ;Is it in this room?                           ;3
       BNE    CheckForMoreObjects ;If not lets try next object (branch)          ;2
       LDA    $95                 ;Check first slot.                             ;3
       CMP    #$90                ;If not default(no-object)(Num Is (8*NumOfObj)-8);2
       BNE    StoreObjectToPrint  ;then branch.                                  ;2
       STY    $95                 ;Store this object's number to print           ;3
       JMP    CheckForMoreObjects ;      and try for more.                       ;3

StoreObjectToPrint:
       STY    $96                 ;Store this object's number to print.          ;3
       JMP    StoreCount          ;      and then give up - no slots free.       ;3

CheckForMoreObjects:
       CPY    $9C                 ;Have we done all the objets?                  ;3
       BNE    MoveNextObject      ;If not, continue.                             ;2

StoreCount:
       STY    $9C                 ;If so, store current count                    ;3
       RTS                        ;      for next time.                          ;6

;Convert room number to address.
RoomNumToAddress:
       STX    $D8                 ;save X                                        ;2
       LDX    #>RoomDataTable     ;initialize the high pointer ( saves one add'n);2
       ASL           ;ROLing carry into $94 not nec. if RoomNumber always < 128  ;2
       ASL           ;ROLing carry into $94 not nec. if RoomNumber always <  64  ;2
       ASL           ;ROLing carry into $94 not nec. if RoomNumber always <  32  ;2
       BCC    .skip0 ; but you are planning some more rooms, so add the code here;2
       INX                                                                       ;2
       CLC                                                                       ;2
.skip0:
       ADC    #<RoomDataTable                                                    ;2
       BCC    .skip1                                                             ;2
       INX                                                                       ;2
.skip1:
       STA    $93                                                                ;2
       STX    $94                                                                ;2
       LDX    $D8                ;restore X                                      ;2

GetObjectState_2:
       RTS                                                                       ;6

;Get pointer to current state.
GetObjectState:
       LDY    #$00                                                               ;2
       LDA    $DC                 ;Get the current object state.                 ;3

GetObjectState_1:
       CMP    ($93),Y             ;Have we found it in the list of states.       ;5
       BCC    GetObjectState_2    ;If nearing it then found it and return        ;2
       BEQ    GetObjectState_2    ;If found it then return.                      ;2
       INY                                                                       ;2
       INY                        ;Goto next state in list of states.            ;2
       INY                                                                       ;2
       JMP    GetObjectState_1                                                   ;3

;Check for input.
CheckInput:
       INC    $E5                 ;Increment low count.                          ;5
       BNE    GetJoystick                                                        ;2
       INC    $E6                 ;Increment hight count if                      ;5
       BNE    GetJoystick         ;      needed.                                 ;2
       LDA    #$80                ;Wrap the high count (indicating               ;2
       STA    $E6                 ;      timeout) if needed.                     ;3

GetJoystick:
       LDA    SWCHA               ;Get joystick values.                          ;4
       CMP    #$FF                ;If any movement then branch.                  ;2
       BNE    GetJoystick_2                                                      ;2
       LDA    SWCHB               ;Get the consol switches                       ;4
       AND    #$03                ;Mast for the reset/select switchs.            ;2
       CMP    #$03                ;Have either of them been used?                ;2
       BEQ    GetJoystick_3       ;If not branch.                                ;2

GetJoystick_2:
       LDA    #$00                ;Zero the high count of the                    ;2
       STA    $E6                 ;      switches or joystick have been used.    ;3

GetJoystick_3:
       RTS                                                                       ;6

;Change color if necessary.
ChangeColor:
       LSR                        ;If bit 0 of the color is set                  ;2
       BCC    ChangeColor_2       ;      then the room is to flash.              ;2
       TAY                        ;Use color as an index (usually E5- the low c) ;2
       LDA.wy $0080,Y             ;Get flash color (usually the low counter.)    ;4

ChangeColor_2:
       LDY    $E6                 ;Get the input counter.                        ;3
       BPL    ChangeColor_3       ;If console/stick moved recently then branch   ;2
       EOR    $E6                 ;Merge the high counter with the color wanted. ;3
       AND    #$FB                ;Keep this color bug merge down the luminance. ;2

ChangeColor_3:
       ASL                        ;And restore original color if necessary.      ;2
       RTS                                                                       ;6

;Get the address of the dynamic information for an object.
GetObjectAddress:
       LDA    Store1,X                                                           ;4
       STA    $93                 ;Get and store the low address.                ;3
       LDA    Store2,X                                                           ;4
       STA    $94                 ;Get and store the high address.               ;3
       RTS                                                                       ;6

;Game Start
StartGame:
       SEI                        ;Set Interupts Off                             ;2
       CLD                                                                       ;2
       LDX    #$28                ;Clear TIA Registers                           ;2
       LDA    #$00                ;&04-&2C i.e. blank                            ;2

ResetAll:
       STA    NUSIZ0,X            ;Everything And Turn.                          ;4
       DEX                        ;Everything Off.                               ;2
       BPL    ResetAll                                                           ;2
       TXS                        ;Reset Stack                                   ;2

SetupVars:
       STA    VSYNC,X             ;Clear &80 to &FF User Vars.                   ;4
       DEX                                                                       ;2
       BMI    SetupVars                                                          ;2

  IF ORIGINAL = 0
;added so the number won't flash if an object is in the "zero" room
       LDA    #$14                ;load a "dark" room number                     ;2
       STA    $D9                 ;...and save it to the invisible surround room ;3
  ENDIF

       JSR    ThinWalls           ;Position the thin walls (missiles)            ;6
       JSR    SetupRoomObjects    ;Setup objects rooms and positions.            ;6

MainGameLoop:
       JSR    CheckGameStart      ;Check for Game Start                          ;6
       JSR    MakeSound           ;Make noise if necessary                       ;6
       JSR    CheckInput          ;Check for input.                              ;6
       LDA    $DE                 ;Is The Game Active?                           ;3
       BNE    NonActiveLoop       ;If Not Branch..                               ;2
       LDA    $B9                 ;Get the room the Chalise is in.               ;3
       CMP    #$12                ;Is it in the yellow castle?                   ;2
       BNE    MainGameLoop_2      ;If Not Branch..                               ;2
       LDA    #$FF                                                               ;2
       STA    $DF                 ;Set the note count to maximum.                ;3
       STA    $DE                 ;Set the game to inactive.                     ;3
       LDA    #$00                ;Set the noise type to end-noise.              ;2
       STA    $E0                                                                ;3

MainGameLoop_2:
       LDY    #$00                ;Allow joystick read - all movement.           ;2
       JSR    BallMovement        ;Check ball collisions and move ball.          ;6
       JSR    MoveCarriedObject   ;Move the Carried Object                       ;6
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    SetupRoomPrint      ;Setup the room and objects for display.       ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JSR    PickupPutdown       ;Deal with object pickup and putdown.          ;6
       LDY    #$01                ;Disallow joystick read - move vertically only.;2
       JSR    BallMovement        ;Check ball collisions and move ball.          ;6
       JSR    Surround            ;Deal With Invisible Surround Moving.          ;6
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    MoveBat             ;Move and deal with bat.                       ;6
       JSR    Portals             ;Move and deal with portcullises.              ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JSR    MoveGreenDragon     ;Move and deal with the green dragon.          ;6
       JSR    MoveYellowDragon    ;Move and deal with the yellow dragon.         ;6
       JSR    DoVSYNC             ;Wait for VSYNC.                               ;6
       LDY    #$02                ;Disallow stick read/bridge check-move hor.only;2
       JSR    BallMovement        ;Check ball collisions and move ball.          ;6
       JSR    MoveRedDragon       ;Move and deal with red dragon.                ;6
       JSR    Mag_1               ;Deal with the magnet.                         ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JMP    MainGameLoop                                                       ;3

;Non Active Game Loop.
NonActiveLoop:
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JSR    SetupRoomPrint      ;Set up room and objects for display.          ;6
       JMP    MainGameLoop                                                       ;3

;Position missiles to "thin wall" areas.
ThinWalls:
       LDA    #$0D                ;Position missile 00 to                        ;2
       LDX    #$02                ;(0D,00) - left thin wall.                     ;2
       JSR    PosSpriteX                                                         ;6
       LDA    #$96                ;Position missile 01 to                        ;2

  IF ORIGINAL
       LDX    #$03                ;(96,00) - right thin wall.                    ;2
  ELSE
       INX
;PosSpriteX does not alter the X register...so we can just increase it
;1 byte saved
  ENDIF

       JSR    PosSpriteX                                                         ;6
       STA    WSYNC                     ;Wait for horizonal blank.               ;3
       STA    HMOVE                     ;Apply the horizonal move.               ;3
       RTS                                                                       ;6

CheckGameStart:
       LDA    SWCHB               ;Get the console switches.                     ;4
       EOR    #$FF                ;Flip (as reset active low).                   ;2
       AND    $92                       ;Compare with what was before            ;3

  IF ORIGINAL
       AND    #$01                      ;And check only the reset switch         ;2
       BEQ    CheckReset          ;If no reset then branch.                      ;2
  ELSE
; testing bit 0 is smaller with LSR:
       LSR                              ;And check only the reset switch         ;2
       BCC    CheckReset          ;If no reset then branch.                      ;2
  ENDIF

       LDA    $DE                 ;Has the Game Started?                         ;3
       CMP    #$FF                ;If not then branch.                           ;2
       BEQ    SetupRoomObjects                                                   ;2
       LDA    #$11                ;Get the yellow castle room.                   ;2
       STA    $8A                       ;Make it the current room.               ;3
       STA    $E2                       ;Make it the previous room.              ;3
       LDA    #$50                ;Get the X coordinate.                         ;2
       STA    $8B                       ;Make it the current ball X coordinate.  ;3
       STA    $E3                       ;Make it the previous ball X coordinate. ;3
       LDA    #$20                ;Get the Y coordinate.                         ;2
       STA    $8C                       ;Make it the current ball Y coordinate.  ;3
       STA    $E4                       ;Make it the previous ball Y coordinate. ;3
       LDA    #$00                                                               ;2
       STA    $A8                 ;Set the red dragon's state to OK.             ;3
       STA    $AD                 ;Set the yellow dragon's state to OK.          ;3
       STA    $B2                 ;Set the green dragon's state to OK.           ;3
       STA    $DF                 ;Set the note count to zero.. (ops!??)         ;3
       LDA    #$90                ;(Num Is (8 * NumOfObj) - 8)                   ;2
       STA    $9D                 ;Set no object being carried.                  ;3

CheckReset:
       LDA    SWCHB               ;Get the console switches.                     ;4
       EOR    #$FF                ;Flip (as select active low)                   ;2
       AND    $92                 ;Compare with what was before.                 ;3
       AND    #$02                ;And check only the select switch.             ;2
       BEQ    StoreSwitches       ;Branch if select not being used.              ;2
       LDA    $8A                 ;Get the Current Room.                         ;3

  IF ORIGINAL
; a lot of superflous code in here:
       CMP    #$00                ;Is it the "Number" room?                      ;2
  ENDIF

       BNE    SetupRoomObjects    ;Branch if not.                                ;2
       LDA    $DD                 ;Increment the level.                          ;3
       CLC                        ;Number (by two).                              ;2
       ADC    #$02                                                               ;2
       CMP    #$06                ;Have we reached the maximum?                  ;2
       BCC    ResetSetup                                                         ;2
       LDA    #$00                ;If yep then set back to zero.                 ;2

ResetSetup:
       STA    $DD                 ;Store the new level number.                   ;3
SetupRoomObjects:
       LDA    #$00                ;Set the current room to the                   ;2
       STA    $8A                 ;"Number" room.                                ;3
       STA    $E2                 ;And the previous room.                        ;3

  IF ORIGINAL
       LDA    #$00                ;Set the ball's Y coordinate to zero.          ;2
  ENDIF
;A is still zero...no need to reload
;2 bytes saved

       STA    $8C                 ;And the previous Y coordinate.                ;3
       STA    $E4                 ;(So can't be seen.)                           ;3
       LDY    $DD                 ;Get the level number.                         ;3
       LDA    Loc_4,Y              ;Get the low pointer to object locations.     ;4
       STA    $93                                                                ;3
       LDA    Loc_5,Y             ;Get the high pointer to object locations.     ;4
       STA    $94                                                                ;3
       LDY    #$30                ;Copy all the objects dynamic information.     ;2

SetupRoomObjects_2:
       LDA    ($93),Y             ;(the rooms and positions) into                ;5
       STA.wy $00A1,Y             ;the working area.                             ;5
       DEY                                                                       ;2
       BPL    SetupRoomObjects_2                                                 ;2
       LDA    $DD                 ;Get the level number.                         ;3
       CMP    #$04                ;Branch if level one.                          ;2
       BCC    SignalGameStart     ;Or two(Where all objects are in defined areas);2
       JSR    RandomizeLevel3     ;Put some objects in random rooms.             ;6
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    PrintDisplay        ;Display rooms and objects.                    ;6

SignalGameStart:
       LDA    #$00                ;Signal that the game has started.             ;2
       STA    $DE                                                                ;3
       LDA    #$90                ;Set no object being carried.(Num Is (8*NumOfObj)-8);2
       STA    $9D                                                                ;3

StoreSwitches:
       LDA    SWCHB               ;Store the current console switches            ;4
       STA    $92                                                                ;3
       RTS                                                                       ;6

;Put objects in random rooms for level 3.
RandomizeLevel3:
       LDY    #$1E                ;For each of the eleven objects..              ;2

RandomizeLevel3_2:
       LDA    $E5                 ;Get the low input counter as seed.            ;3
       LSR                                                                       ;2
       LSR                                                                       ;2
       LSR                        ;Generate a psudo-random                       ;2
       LSR                        ;room number.                                  ;2
       LSR                                                                       ;2
       SEC                                                                       ;2
       ADC    $E5                 ;Store the low input counter.                  ;3
       STA    $E5                                                                ;3
       AND    #$1F                ;Trim so represents a room value.              ;2
       CMP    Loc_2,Y             ;If it is less than the                        ;4
       BCC    RandomizeLevel3_2   ;lower bound for object then get another.      ;2
       CMP    Loc_3,Y             ;If it equals or is                            ;4
       BEQ    RandomizeLevel3_3   ;Less than the higher bound for object         ;2
       BCS    RandomizeLevel3_2   ;Then continue (branch if higher)              ;2
RandomizeLevel3_3:
       LDX    Loc_1,Y             ;Get the dynamic data index for this object    ;4
       STA    VSYNC,X             ;Store the new room value.                     ;4
       DEY                                                                       ;2
       DEY                        ;Goto the next object.                         ;2
       DEY                                                                       ;2
       BPL    RandomizeLevel3_2   ;Untill all done                               ;2
       RTS                                                                       ;6

;Check ball collisions and move ball.
BallMovement:

  IF ORIGINAL
       LDA    CXBLPF                                                             ;3
       AND    #$80                ;Get ball-playfield collision                  ;2
       BNE    PlayerCollision     ;Branch if collision (Player-Wall)             ;2
       LDA    CXM0FB                                                             ;3
       AND    #$40                ;Get ball-missile00 collision.                 ;2
       BNE    PlayerCollision     ;Branch if collision. (Player-Left Thin)       ;2
       LDA    CXM1FB                                                             ;3
       AND    #$40                ;Get ball-missile01 collision.                 ;2
       BEQ    BallMovement_2      ;Branch if no collision.                       ;2
  ELSE
; using BIT to check the two most significant bytes:
       BIT    CXBLPF              ;Get ball-playfield collision                  ;3
       BMI    PlayerCollision     ;Branch if collision (Player-Wall)             ;2
       BIT    CXM0FB              ;Get ball-missile00 collision.                 ;3
       BVS    PlayerCollision     ;Branch if collision. (Player-Left Thin)       ;2
       BIT    CXM1FB              ;Get ball-missile01 collision.                 ;3
       BVC    BallMovement_2      ;Branch if no collision.                       ;2
; 6 bytes saved
  ENDIF

       LDA    $96                 ;If object2 (to print) is                      ;3
       CMP    #$78                ;      not the black dot then collide.         ;2
       BNE    PlayerCollision                                                    ;2
BallMovement_2:

;using BIT to check the flags instead of AND...
  IF ORIGINAL
       LDA    CXP0FB                                                             ;3
       AND    #$40                ;Get ball-player00 collision.                  ;2
       BEQ    BallMovement_3      ;If no collision then branch.                  ;2
  ELSE
       BIT    CXP0FB                                                             ;3
       BVC    BallMovement_3      ;If no collision then branch.                  ;2
;2 bytes saved
  ENDIF

       LDA    $95                 ;If object1 (to print) is                      ;3

  IF ORIGINAL
       CMP    #$00                ;      not the invisible surround then         ;2
  ENDIF
       BNE    PlayerCollision     ;      branch (collision)                      ;2

BallMovement_3:

;using BIT to check the flags instead of AND (again)...
  IF ORIGINAL
       LDA    CXP1FB                                                             ;3
       AND    #$40                ;Get ball-player01 collision.                  ;2
       BEQ    NoCollision         ;If no collision then branch.                  ;2
  ELSE
       BIT    CXP1FB                                                             ;3
       BVC    BallMovement_3      ;If no collision then branch.                  ;2
;2 bytes saved
  ENDIF

       LDA    $96                 ;If player01 to print is                       ;3

  IF ORIGINAL
       CMP    #$00                ;      not the invisible surround then         ;2
  ENDIF

       BNE    PlayerCollision     ;      branch (collision)                      ;2
       JMP    NoCollision         ;No collision - branch.                        ;3

;Player collided (with something)
PlayerCollision:
       CPY    #$02                ;Are we checking for the bridge?               ;2
       BNE    ReadStick           ;If not, branch.                               ;2
       LDA    $9D                 ;Get the object being carried.                 ;3
       CMP    #$50                ;Branch if it is the bridge.             ;2
       BEQ    ReadStick                                                          ;2
       LDA    $8A                 ;Get the current room.                         ;3
       CMP    $BC                 ;Is the bridge in this room.                   ;3
       BNE    ReadStick           ;If not branch.                                ;2

;Check going through the bridge.
       LDA    $8B                 ;Get the ball's X coordinate.                  ;3
       SEC                                                                       ;2
       SBC    $BD                 ;Subtract the bridge's X coordinate.           ;3
       CMP    #$0A                ;If less than &0A then forget it.              ;2
       BCC    ReadStick                                                          ;2
       CMP    #$17                ;If more than &17 then forget it.              ;2
       BCS    ReadStick                                                          ;2
       LDA    $BE                 ;Get the bridge's Y coordinate.                ;3
       SEC                                                                       ;2
       SBC    $8C                 ;Subtrac the ball's Y coordinate.              ;3
       CMP    #$FC                                                               ;2
       BCS    NoCollision         ;If more than &FC then going through bridge.   ;2
       CMP    #$19                ;If more than &19 then forget it.              ;2
       BCS    ReadStick                                                          ;2

;No collision (and going through bridge)
NoCollision:
       LDA    #$FF                ;Reset the joystick input.                     ;2
       STA    $99                                                                ;3
       LDA    $8A                 ;Get the current room.                         ;3
       STA    $E2                 ;      and store temporarily.                  ;3
       LDA    $8B                 ;Get the ball's X coordinate.                  ;3
       STA    $E3                 ;      and store temporarily.                  ;3
       LDA    $8C                 ;Get the ball's Y coordinate.                  ;3
       STA    $E4                 ;And Store Temporarily.                        ;3

;Read Sticks
ReadStick:
  IF ORIGINAL
       CPY    #$00                ;???Is game in first phase?                    ;2
  ELSE
; if A is not needed, this is shorter:
       TYA                        ;???Is game in first phase?                    ;2
; 1 byte saved
  ENDIF
       BNE    ReadStick_2         ;If not, don't bother with joystick read.      ;2

       LDA    SWCHA               ;Read joysticks.                               ;4
       STA    $99                 ;      and store value.                        ;3

ReadStick_2:
       LDA    $E2                 ;Get Temporary room.                           ;3
       STA    $8A                 ;      and make it the current room.           ;3
       LDA    $E3                 ;Get temporary X coordinate                    ;3
       STA    $8B                 ;      and make it the man's X coordinate.     ;3
       LDA    $E4                 ;Get temporary Y coordinate                    ;3
       STA    $8C                 ;      and make it the man's Y coordinate.     ;3

       LDA    $99                 ;Get the Joystick position.                    ;3
       ORA    ReadStick_3,Y       ;Merge out movement not allowed in this phase. ;4
       STA    $9B                 ;And store cooked movement.                    ;3

       LDY    #$03                ;Set the delta for the ball.                   ;2
       LDX    #$8A                ;Point to ball's coordiates.                   ;2
  IF ORIGINAL
       JSR    MoveGroundObject    ;Move the ball                                 ;6
       RTS                                                                       ;6
  ELSE
; replacing JSR, RTS with JMP is also a very common trick (you can also try BNE here):
       JMP    MoveGroundObject     ;Move the ball                                ;6
; 1 byte saved
  ENDIF

;Joystick Merge Values
ReadStick_3:
       .byte $00,$C0,$30            ;No change, No horizontal, No vertical.

;Deal with object pickup and putdown.
PickupPutdown:
       ROL    INPT4               ;Get joystick trigger.                         ;5
       ROR    $D7                 ;Merget into joystick record.                  ;5
       LDA    $D7                 ;Get joystick record.                          ;3
       AND    #$C0                ;Merget out previous presses.                  ;2
       CMP    #$40                ;Was it previously pressed?                    ;2
       BNE    PickupPutdown_2     ;If not branch.                                ;2

       LDA    #$90                ;(Num Is (8 * NumOfObj) - 8)                   ;2
       CMP    $9D                 ;If nothing is being carried                   ;3
       BEQ    PickupPutdown_2     ;      then branch.                            ;2

       STA    $9D                 ;Drop object.                                  ;3
       LDA    #$04                ;Set noise type to four.                       ;2
       STA    $E0                                                                ;3
  IF ORIGINAL
; this is very obvious:
       LDA    #$04                ;Set noise count to four.                      ;2
  ENDIF
       STA    $DF                                                                ;3

PickupPutdown_2:
       LDA    #$FF                ;????                                          ;2
       STA    $98                                                                ;3

;Check for collision.
       LDA    CXP0FB                                                             ;3
       AND    #$40                ;Get Ball-Player00 collision.                  ;2
       BEQ    PickupPutdown_3     ;If nothing occured then branch.               ;2

;With Player00
       LDA    $95                 ;Get type of Player00                          ;3
       STA    $97                 ;And Store.                                    ;3
       JMP    CollisionDetected   ;Deal with collision.                          ;3

PickupPutdown_3:
       LDA    CXP1FB                                                             ;3
       AND    #$40                ;Get Ball-Player01 collision.                  ;2
       BEQ    PickupPutdown_4     ;If nothing has happened, branch.              ;2

       LDA    $96                 ;Get type of Player01                          ;3
       STA    $97                 ;      and store.                              ;3
       JMP    CollisionDetected   ;Deal with collision.                          ;3

PickupPutdown_4:
       JMP    NoObject            ;Deal with no collision (return).              ;3

;Collision occured.
CollisionDetected:
       LDX    $97                 ;Get the object collided with.                 ;3
       JSR    GetObjectAddress    ;Get it's dynamic information.                 ;6
       LDA    $97                 ;Get the object collided with.                 ;3
       CMP    #$48                ;Is it carriable?  'SWORD?? 51 SET TO 48       ;2
       BCC    NoObject            ;If not, branch.                               ;2

  IF ORIGINAL
; more redundant code --
       LDY    #$00                                                               ;2
       LDA    ($93),Y             ;Get the object's room.                        ;5
       CMP    $8A                 ;Is it in the current room?                    ;3
       BNE    NoObject            ;If not, branch.                               ;2
;if you collided with something, obviously it's in the same room (8 bytes saved)
  ENDIF

       LDA    $97                 ;Get the object collided with.                 ;3
       CMP    $9D                 ;Is it the object being carried?               ;3
       BEQ    PickupObject        ;If so, branch (and actually pick it up.)      ;2
       LDA    #$05                ;Set noise type to five.                       ;2
       STA    $E0                                                                ;3
       LDA    #$04                ;Set noise type to four.                       ;2
       STA    $DF                                                                ;3

PickupObject:
       LDA    $97                 ;Set the object as being                       ;3
       STA    $9D                 ;      carried.                                ;3
       LDX    $93                 ;Get the dynamice address low byte.            ;3
       LDY    #$06                                                               ;2
       LDA    $99                 ;????                                          ;3
       JSR    MoveObjectDelta     ;????                                          ;6
       LDY    #$01                                                               ;2
       LDA    ($93),Y             ;Get the object's X coordinate.                ;5
       SEC                                                                       ;2
       SBC    $8B                 ;Subtract the ball's X coordinate.             ;3
       STA    $9E                 ;      and store the difference.               ;3

  IF ORIGINAL
       LDY    #$02                                                               ;2
  ELSE
;Y hasn't changed...just use INY instead
       INY                                                                       ;2
;1 byte saved
  ENDIF

       LDA    ($93),Y             ;Get the object's Y coordinate.                ;5
       SEC                                                                       ;2
       SBC    $8C                 ;Subtract the Ball's Y coordinate.             ;3
       STA    $9F                 ;      and store the difference.               ;3

;No collision
NoObject:
       RTS                                                                       ;6


;Move the carried object
MoveCarriedObject:
       LDX    $9D                 ;Get the object being carried.                 ;3
       CPX    #$90     ;If nothing then branch (return)(Num Is (8*NumOfObj)-8)   ;2
       BEQ    MoveCarriedObject_2                                                ;2
       JSR    GetObjectAddress    ;Get it's dynamic information.                 ;6
       LDY    #$00                                                               ;2
       LDA    $8A                 ;Get the current room.                         ;3
       STA    ($93),Y             ;      and stroe the object's current room.    ;6

  IF ORIGINAL
       LDY    #$01                                                               ;2
  ELSE
;Y hasn't changed...just use INY instead
       INY                                                                       ;2
;1 byte saved
  ENDIF

       LDA    $8B                 ;Get the ball's X coordinate.                  ;3
       CLC                                                                       ;2
       ADC    $9E                 ;Add the X difference.                         ;3
       STA    ($93),Y             ;      and store as the object's X coordinate. ;6

  IF ORIGINAL
       LDY    #$02                                                               ;2
  ELSE
;Y hasn't changed...just use INY instead
       INY                                                                       ;2
;1 byte saved
  ENDIF

       LDA    $8C                 ;Get the ball's Y coordinate.                  ;3
       CLC                                                                       ;2
       ADC    $9F                 ;Add the Y difference.                         ;3
       STA    ($93),Y             ;      and store as the object's Y coordinate. ;6
       LDY    #$00                ;Set no delta.                                 ;2
       LDA    #$FF                ;Set no movement.                              ;2
       LDX    $93                 ;Get the object's dynamic address.             ;3

  IF ORIGINAL
       JSR    MoveGroundObject     ;Move the object.                             ;6
MoveCarriedObject_2:
       RTS                                                                       ;6
  ELSE
       JMP    MoveGroundObject     ;Move the object.                             ;6
  ENDIF

;Move the object.
MoveGroundObject:
       JSR    MoveObjectDelta     ;Move the object by delta.                     ;6
       LDY    #$02                ;Set to do the three                           ;2
MoveGroundObject_2:
       STY    $9A                 ;      portcullises.                           ;3
       LDA.wy $00C8,Y             ;Get the portal state.                         ;4
       CMP    #$1C                ;Is it in a closed state?                      ;2
       BEQ    GetPortal           ;If not, next portal.                          ;2

;Deal with object moving out of a castle.
       LDY    $9A                 ;Get port number.                              ;3
       LDA    VSYNC,X             ;Get object's room number.                     ;4
       CMP    EntryRoomOffsets,Y  ;Is it in a castle entry room.                 ;4
       BNE    GetPortal           ;If not, next portal.                          ;2
       LDA    WSYNC,X             ;Get the object's Y coordinate.                ;4
       CMP    #$0D                ;Is it above &OD i.e at the bottom.            ;2
       BPL    GetPortal           ;If so then branch.                            ;2
       LDA    CastleRoomOffsets,Y ;Get the castle room.                          ;4
       STA    VSYNC,X             ;And put the object in the castle room.        ;4
       LDA    #$50                                                               ;2
       STA    VBLANK,X            ;Set the object's new X coordinate.            ;4
       LDA    #$2C                                                               ;2
       STA    WSYNC,X             ;Set the new object's Y coordinate.            ;4
       LDA    #$01                                                               ;2
       STA.wy $00C8,Y             ;Set the portcullis state to 01.               ;5

  IF ORIGINAL = 0
MoveCarriedObject_2:
  ENDIF

       RTS                                                                       ;6

GetPortal:
       LDY    $9A                 ;Get the portcullis number.                    ;3
       DEY                        ;      goto next,                              ;2
       BPL    MoveGroundObject_2  ;      and continue.                           ;2

;Check and Deal with Up.
       LDA    WSYNC,X             ;Get the object's Y coordinate.                ;4
       CMP    #$6A                ;Has it reched above the top.                  ;2
       BMI    DealWithLeft        ;If not, branch.                               ;2
       LDA    #$0D                ;Set new Y coordinate to bottom.               ;2
       STA    WSYNC,X                                                            ;4
       LDY    #$04                ;Get the direction wanted.                     ;2
       JMP    GetNewRoom          ;Go and get new room.                          ;3

;Check and Deal with Left.
DealWithLeft:
       LDA    VBLANK,X            ;Get the object's X coordinate.                ;4
       CMP    #$03                ;Is it Three or less?                          ;2
       BCC    DealWithLeft_2      ;IF so, branch.  (off to left)                 ;2
       CMP    #$F0                ;Is it's &F0 or more.                          ;2
       BCS    DealWithLeft_2      ;If so, branch.  (off to right)                ;2
       JMP    DealWithDown                                                              ;3

DealWithLeft_2:
       CPX    #$8A                ;Are we dealling with the ball?                ;2
       BEQ    DealWithLeft_3      ;If so Branch.                                 ;2
       LDA    #$9A                ;Set new X coordinate for the others.          ;2
       JMP    DealWithLeft_4                                                     ;3

DealWithLeft_3:
       LDA    #$9E                ;Set new X coordinate for the ball.            ;2

DealWithLeft_4:
       STA    VBLANK,X            ;Store the next X coordinate.                  ;4
       LDY    #$07                ;And get the direction wanted.                 ;2
       JMP    GetNewRoom          ;Go and get new room.                          ;3

;Check and Deal with Down.
DealWithDown:
       LDA    WSYNC,X             ;Get object's Y coordinate.                    ;4
       CMP    #$0D                ;If it's greater than &0D then                 ;2
       BCS    DealWithRight       ;Branch.                                       ;2
       LDA    #$69                ;Set new Y coordinate.                         ;2
       STA    WSYNC,X                                                            ;4
       LDY    #$06                ;Get the direction wanted.                     ;2
       JMP    GetNewRoom          ;Go and get new room.                          ;3

;Check and Deal with Right.
DealWithRight:
       LDA    VBLANK,X            ;Get the object's X coordinate.                ;4
       CPX    #$8A                ;Are we dealing with the ball.                 ;2
       BNE    DealWithRight_2     ;Branch if not.                                ;2
       CMP    #$9F                ;Has the object reached the right?             ;2
       BCC    MovementReturn      ;Branch if not.                                ;2
       LDA    VSYNC,X             ;Get the Ball's Room.                          ;4
       CMP    #$03                ;Is it room #3 (Right to secret room)          ;2
       BNE    DealWithRight_3     ;Branch if not.                                ;2
       LDA    $A1                 ;Check the room of the black dot.              ;3
       CMP    #$15                ;Is it in the hidden room area?                ;2
       BEQ    DealWithRight_3     ;If so, Branch.                                ;2

;Manually change to secret room.
       LDA    #$1E                ;Set room to secret room.                      ;2
       STA    VSYNC,X             ;And make it current.                          ;4
       LDA    #$03                ;Set the X coordinate.                         ;2
       STA    VBLANK,X                                                           ;4
       JMP    MovementReturn      ;And Exit.                                     ;3

DealWithRight_2:
       CMP    #$9B                ;Has the object reached the right of screen?   ;2
       BCC    MovementReturn      ;Branch if not (no room change)                ;2

DealWithRight_3:
       LDA    #$03                ;Set the next X coordinate.                    ;2
       STA    VBLANK,X                                                           ;4
       LDY    #$05                ;And get the direction wanted.                 ;2
       JMP    GetNewRoom          ;Get the new room.                             ;3

;Get new room
GetNewRoom:
       LDA    VSYNC,X             ;Get the object's room.                        ;4
       JSR    RoomNumToAddress    ;Convert it to an address.                     ;6
       LDA    ($93),Y             ;Get the adjacent room.                        ;5
       JSR    AdjustRoomLevel     ;Deal with the level differences.              ;6
       STA    VSYNC,X             ;      and store as new object's room.         ;4

MovementReturn:
       RTS                                                                       ;6

;Move the object in direction by delta.
MoveObjectDelta:
       STA    $9B                 ;Stored direction wanted.                      ;3
MoveObjectDelta_2:
       DEY                        ;Count down the delta.                         ;2

  IF ORIGINAL
       BMI    MoveObjectDelta_7                                                  ;2
  ELSE
       BMI    MovementReturn       INY                                           ;2
  ENDIF

;more use of the BIT instruction...
  IF ORIGINAL
       LDA    $9B                 ;Get direction wanted.                         ;3
       AND    #$80                ;Check for right move.                         ;2
       BNE    MoveObjectDelta_3   ;If no move right then branch.                 ;2
  ELSE
       BIT    $9B                 ;Get direction wanted.                         ;3
       BMI    MoveObjectDelta_3   ;If no move right then branch.                 ;2
  ENDIF

       INC    VBLANK,X            ;Increment the X coordinate.                   ;6

MoveObjectDelta_3:

  IF ORIGINAL
       LDA    $9B                 ;Get the direction wanted.                     ;3
       AND    #$40                ;Check for left move.                          ;2
       BNE    MoveObjectDelta_4   ;If no move left then branch.                  ;2
  ELSE
       BIT    $9B                 ;Get the direction wanted.                     ;3
       BVS    MoveObjectDelta_4   ;If no move left then branch.                  ;2
  ENDIF

       DEC    VBLANK,X            ;Decrement the X coordinate.                   ;6

MoveObjectDelta_4:
       LDA    $9B                 ;Get the direction wanted.                     ;3
       AND    #$10                ;Check for move up.                            ;2
       BNE    MoveObjectDelta_5   ;If no move up then branch.                    ;2
       INC    WSYNC,X                                                            ;6

MoveObjectDelta_5:
       LDA    $9B                 ;Get direction wanted.                         ;3
       AND    #$20                ;Check for move down.                          ;2
       BNE    MoveObjectDelta_6   ;If no move down the branch.                   ;2
       DEC    WSYNC,X             ;Decrement the Y coordinate.                   ;6

MoveObjectDelta_6:
       JMP    MoveObjectDelta_2   ;Keep going until delta finished.              ;3

  IF ORIGINAL
MoveObjectDelta_7:
       RTS                                                                       ;6
  ENDIF

;Adjust room for different levels.
AdjustRoomLevel:
       CMP    #$80                ;Is the room number                            ;2
       BCC    AdjustRoomLevel_2   ;      above &80?                              ;2
       SEC                                                                       ;2
       SBC    #$80                ;Remove the &80 flag and                       ;2
       STA    $D8                 ;      store the room number.                  ;3
       LDA    $DD                 ;Get the level number.                         ;3
       LSR                        ;Devide it by two.                             ;2
       CLC                                                                       ;2
       ADC    $D8                 ;Add to the original room.                     ;3
       TAY                                                                       ;2
       LDA    RoomDiffs,Y             ;Use as an offset to get the next room.    ;4

AdjustRoomLevel_2:
       RTS                                                                       ;6

;Get player-ball collision.
PBCollision:
       CMP    $95                 ;Is it the rist object?                        ;3
       BEQ    PBCollision_2       ;YES - Then Branch.                            ;2
       CMP    $96                 ;Is it the second object?                      ;3
       BEQ    PBCollision_3       ;YES - Then Branch.                            ;2
       LDA    #$00                ;Otherewise nothing.                           ;2
       RTS                                                                       ;6

PBCollision_2:
       LDA    CXP0FB              ;Get player00-ball collision.                  ;3
       AND    #$40                                                               ;2
       RTS                                                                       ;6

PBCollision_3:
       LDA    CXP1FB              ;Get player01-ball collision.                  ;3
       AND    #$40                                                               ;2
       RTS                                                                       ;6


;Find which object has hit object wanted.
FindObjHit:

  IF ORIGINAL
       LDA    CXPPMM              ;Get Player00-Player01                         ;3
       AND    #$80                ;      collision.                              ;2
       BEQ    FindObjHit_2        ;If nothing, Branch.                           ;2
  ELSE
       BIT    CXPPMM              ;Get Player00-Player01                         ;3
       BPL    FindObjHit_2        ;If nothing, Branch.                           ;2
  ENDIF

       CPX    $95                 ;Is object 1 the one being hit?                ;3
       BEQ    FindObjHit_3        ;If so, Branch.                                ;2

       CPX    $96                 ;Is object 2 the one being hit?                ;3
       BEQ    FindObjHit_4        ;If so, Branch.                                ;2

FindObjHit_2:
       LDA    #$90                ;Therefore select the other.(Num Is (8*NumOfObj)-8) ;2
       RTS                                                                       ;6

FindObjHit_3:
       LDA    $96                 ;Therefore select the other.                   ;3
       RTS                                                                       ;6

FindObjHit_4:
       LDA    $95                 ;Therefore select the other.                   ;3
       RTS                                                                       ;6


;Move object.
MoveGameObject:
       JSR    GetLinkedObject     ;Get liked object and movement.                ;6
       LDX    $D5                 ;Get dynamic data address.                     ;3
       LDA    $9B                 ;Get Movement.                                 ;3
       BNE    MoveGameObject_2    ;If movement then branch.                      ;2
       LDA    RSYNC,X             ;Use old movement.                             ;4

MoveGameObject_2:
       STA    RSYNC,X             ;Stoe the new movement.                        ;4
       LDY    $D4                 ;Get the object's Delta.                       ;3

  IF ORIGINAL
       JSR    MoveGroundObject    ;Move the object.                              ;6
       RTS                                                                       ;6
  ELSE
       JMP    MoveGroundObject    ;Move the object.                              ;6
  ENDIF

;Find liked object and get movement.
GetLinkedObject:
       LDA    #$00                ;Set index to zero.                            ;2
       STA    $E1                                                                ;3

GetLinkedObject_2:
       LDY    $E1                 ;Get index.                                    ;3
       LDA    ($D2),Y             ;Get first object.                             ;5
       TAX                                                                       ;2
       INY                                                                       ;2
       LDA    ($D2),Y             ;Get second object.                            ;5
       TAY                                                                       ;2
       LDA    VSYNC,X             ;Get object1;s room.                           ;4
       CMP.wy $0000,Y             ;Combare with object2's room.                  ;4
       BNE    GetLinkedObject_3   ;If not the same room then branch.             ;2
       CPY    $D6                 ;Have we matched the second object             ;3
       BEQ    GetLinkedObject_3   ;      for difficulty (if so, carry on).       ;2
       CPX    $D6                 ;Have we matched the first object              ;3

  IF ORIGINAL
       BEQ    GetLinkedObject_3   ;      for difficulty (if so, carry on).       ;2
       JSR    GetLinkedObject_4   ;Get object's movement.                        ;6
       RTS                                                                       ;6
  ELSE
; here we can combine two tricks:
       BNE    GetLinkedObject_4   ;Get object's movement.                        ;6
; 4 bytes saved
  ENDIF

GetLinkedObject_3:
       INC    $E1                 ;Increment the index.                          ;5
       INC    $E1                                                                ;5
       LDY    $E1                 ;Get the index number.                         ;3
       LDA    ($D2),Y             ;Check for end of sequence.                    ;5
       BNE    GetLinkedObject_2   ;If not branch.                                ;2

  IF ORIGINAL
; we know, A must be zero:
       LDA    #$00                ;Set no move if no                             ;2
; 2 bytes saved
  ENDIF

       STA    $9B                 ;      liked object is found.                  ;3
       RTS                                                                       ;6

;Work out object's movement.
GetLinkedObject_4:
       LDA    #$FF                ;Set object movement to none.                  ;2
       STA    $9B                                                                ;3
       LDA.wy $0000,Y             ;Get oject2's room.                            ;4
       CMP    VSYNC,X             ;Compare it with object's room.                ;4
       BNE    GetLinkedObject_8   ;If not the same, forget it.                   ;2
       LDA.wy $0001,Y             ;Get Object2's X coordinate.                   ;4
       CMP    VBLANK,X            ;Get Object1;s X coordinate.                   ;4
       BCC    GetLinkedObject_5   ;If Object2 to left of Object1 then Branch.    ;2
       BEQ    GetLinkedObject_6   ;If Object2 on Object1 then Branch.            ;2


  IF ORIGINAL
       LDA    $9B                 ;Get Object Movement.                          ;3
       AND    #$7F                ;Signal a move right.                          ;2
       STA    $9B                                                                ;3
       JMP    GetLinkedObject_6   ;Now try Vertical.                             ;3
GetLinkedObject_5:
       LDA    $9B                 ;Get object movent.                            ;3
       AND    #$BF                ;Signal a move left.                           ;2
       STA    $9B                                                                ;3
  ELSE
; this one is a bit tricky:
; 1. v1 AND v2 == v2 AND v1, so we can swap this
; 2. now we can resuse the AND and STA code
; 3. we use bit to "hide" the next instruction and save a jump
       LDA    #$7F                ;Signal a move right.                          ;2
       .byte  $2c                 ; opcode for BIT.w                             ;3
GetLinkedObject_5:
       LDA    #$BF                ;Signal a move left.                           ;2
GetLinkedObject_5b
       AND    $9B                 ;Get object movent.                            ;3
       STA    $9B                                                                ;3
;6 bytes saved
  ENDIF

GetLinkedObject_6:
       LDA.wy $0002,Y             ;Get Object2's Y Coordinate.                   ;4
       CMP    WSYNC,X             ;Get Object1's X Coordinate.                   ;4
       BCC    GetLinkedObject_7   ;If Object2 Below Object1 Then Branch.         ;2
       BEQ    GetLinkedObject_8   ;If Object2 on Object1 Then Branch.            ;2
       LDA    $9B                 ;Get Object Movement.                          ;3
       AND    #$EF                ;Signal a move up.                             ;2
       STA    $9B                                                                ;3
       JMP    GetLinkedObject_8   ;Jump to Finish.                               ;3

GetLinkedObject_7:
       LDA    $9B                 ;Get Object Movement.                          ;3
       AND    #$DF                ;Signal a move down.                           ;2
       STA    $9B                                                                ;3

GetLinkedObject_8:
       LDA    $9B                 ;Get the Move.                                 ;3
       RTS                                                                       ;6



; WARNING! This optimization is rather complicated:
; a. we move all tables before the code for two reasons:
;    1. to have them close together (they *must* be on the same page!)
;    2. to avoid to jump over them
; b. we try to reuse as much code as possible
; c. we replace JSR, RTS with BNE

;Move the Red Dragon
MoveRedDragon:
       LDA    #<RedDragMatrix                                                    ;2
       LDY    #$03                                                               ;2
       LDX    #$30                ;Select Dragon #1 : Red                        ;2
       BNE    MoveDragon

;Move the Yellow Dragon.
MoveYellowDragon:
       LDA    #<YelDragMatrix                                                    ;2
       LDY    #$02                                                               ;2
       LDX    #$38                                                               ;2
       BNE    MoveDragon          ;Select Dragon #2 : Yellow.                    ;3

;Move the Green Dragon
MoveGreenDragon:
       LDA    #<GreenDragonMatrix                                                ;2
       LDY    #$02                                                               ;2
       LDX    #$40                ;Select Dragon #3 : Green                      ;2

;Move A Dragon
MoveDragon:
       STA    $D2                 ;Set Low Address of Object Store.              ;3
       STY    $D4                 ;Set the Green Dragon's Delta.                 ;3

    IF (>RedDragMatrix != >YelDragMatrix) || (>RedDragMatrix != >GreenDragonMatrix)
; If this error occurs, the optimization doesn't work because the three tables are not on the same page.
; You can try to move them somewhere else, the best way is to move all data at the end of the code. There
; you can rearrange them much easier.1
       ECHO "Error: High DragonMatrix pointer not equal!"
       ERR
    ENDIF
       LDA    #>RedDragMatrix                                                    ;2
       STA    $D3                 ;Set High Address of Object Store.             ;3
; count yourself :-)



       STX    $A0                 ;Save Object were dealing with.                ;3
       LDA    Store1,X             ;Get the Object's Dynamic Data.               ;4
       TAX                                                                       ;2
       LDA    NUSIZ0,X            ;Get the Object's State.                       ;4
       BNE    MoveDragon_6        ;Branch if not.                                ;2

;Dragon Normal (State 1)
  IF ORIGINAL
       LDA    SWCHB               ;Read console switches.                        ;4
       AND    #$80                ;Check for P1 difficulty.                      ;2
       BEQ    MoveDragon_2        ;If Amateur Branch.                            ;2
  ELSE
       BIT    SWCHB               ;Read console switches.                        ;4
       BPL    MoveDragon_2        ;If Amateur Branch.                            ;2
  ENDIF

       LDA    #$00                ;Set Hard - Ignore Nothing                     ;2
       JMP    MoveDragon_3                                                       ;3

MoveDragon_2:
       LDA    #$B6                ;Set Easy - Ignore Sword.                      ;2

MoveDragon_3:
       STA    $D6                 ;Store Difficulty                              ;3
       STX    $D5                 ;Store Dynamic Data Address.                   ;3
       JSR    MoveGameObject                                                     ;6
       LDA    $A0                 ;Get Object                                    ;3
       JSR    PBCollision         ;      And get the Player-Ball collision.      ;6
       BEQ    MoveDragon_4        ;If None Then Branch.                          ;2
       LDA    SWCHB               ;Get Console Switched.                         ;4
       ROL                        ;Move P0 difficulty to                         ;2
       ROL                        ;      bit 01 position.                        ;2
       ROL                                                                       ;2
       AND    #$01                ;Mask it out.                                  ;2
       ORA    $DD                 ;Merge in the Level Number.                    ;3
       TAY                        ;Create Lookup.                                ;2
       LDA    DragonDiff,Y             ;Get New State.                           ;4
       STA    NUSIZ0,X            ;Store as Dragon's State (Open Mouthed).       ;4
       LDA    $E3                                                                ;3
       STA    VBLANK,X            ;Get Temp Ball X Coord and Store as Dragon's.  ;4
       LDA    $E4                                                                ;3
       STA    WSYNC,X             ;Get Temp Ball Y Coord and Store as Dragon's   ;4
       LDA    #$01                                                               ;2
       STA    $E0                 ;Set Noise Type to 01                          ;3
       LDA    #$10                                                               ;2
       STA    $DF                 ;Set Noise Count to 10 i.e. make roar noise.   ;3

MoveDragon_4:
       STX    $9A                 ;Store Object's Dynamic Data Address.          ;3
       LDX    $A0                 ;Get the Object Number.                        ;3
       JSR    FindObjHit          ;See if anoher object has hit the dragon.      ;6
       LDX    $9A                 ;Get the Object Address.                       ;3
       CMP    #$48                ;Has the Sword hit the Dragon?                 ;2
       BNE    MoveDragon_5        ;If Not, Branch.                               ;2
       LDA    #$01                ;Set the State to 01 (Dead)                    ;2
       STA    NUSIZ0,X                                                           ;4
       LDA    #$03                ;Set Sound Three.                              ;2
       STA    $E0                                                                ;3
       LDA    #$10                ;Set a Noise count of &10.                     ;2
       STA    $DF                                                                ;3

MoveDragon_5:
       JMP    MoveDragon_9        ;Jump to Finish.                               ;3

MoveDragon_6:
       CMP    #$01                ;Is it in State 01 (Dead)                      ;2
       BEQ    MoveDragon_9        ;Branch if So (Return)                         ;2
       CMP    #$02                ;Is it int State 02 (Normal #2)                ;2
       BNE    MoveDragon_7        ;Branch if Not.                                ;2

;Normal Dragon State 2 (Eaten Ball)
       LDA    VSYNC,X             ;Get the Dragon's Current Room.                ;4
       STA    $8A                 ;Store as the Ball's Current Room              ;3
       STA    $E2                 ;      and Previous Room.                      ;3
       LDA    VBLANK,X            ;Get the Dragon's X Coordinate.                ;4
       CLC                                                                       ;2
       ADC    #$03                ;Adjust                                        ;2
       STA    $8B                 ;      and store as the ball's X coordinate.   ;3
       STA    $E3                 ;      and previous X coordinate.              ;3
       LDA    WSYNC,X             ;Get the Dragon's Y coordinate.                ;4
       SEC                                                                       ;2
       SBC    #$0A                ;Adjust                                        ;2
       STA    $8C                 ;      and store as the ball's Y coordinate.   ;3
       STA    $E4                 ;      and the previous Y coordinate.          ;3
       JMP    MoveDragon_9                                                       ;3


;Dragon Roaring.
MoveDragon_7:
       INC    NUSIZ0,X            ;Increment the Dragon's State.                 ;6
       LDA    NUSIZ0,X            ;Get it's State.                               ;4
       CMP    #$FC                ;Is it near the end?                           ;2
       BCC    MoveDragon_9        ;If Not, Branch.                               ;2

       LDA    $A0                 ;Get the Dragon's Number.                      ;3
       JSR    PBCollision         ;Check if the Ball is colliding.               ;6
       BEQ    MoveDragon_9        ;If not, Branch.                               ;2
       LDA    #$02                ;Set the State to State 02 : Eaten             ;2
       STA    NUSIZ0,X                                                           ;4
       LDA    #$02                ;Set noise two.                                ;2
       STA    $E0                                                                ;3
       LDA    #$10                ;Set the Count of Noise to &10.                ;2
       STA    $DF                                                                ;3
       LDA    #$9B                ;Get the Maximum X Coordinate.                 ;2
       CMP    VBLANK,X            ;Compare with the Dragon's X Coordinate.       ;4
       BEQ    MoveDragon_8                                                       ;2
       BCS    MoveDragon_8                                                       ;2
       STA    VBLANK,X            ;If too large then Use It.                     ;4

MoveDragon_8:
       LDA    #$17                ;Set Minimum Y Coordinate.                     ;2
       CMP    WSYNC,X             ;Compare with the Dragon's Y Coordinate.       ;4
       BCC    MoveDragon_9                                                       ;2
       STA    WSYNC,X             ;If Too Small, set as Dragon's Y coordinate.   ;4

MoveDragon_9:
       RTS                                                                       ;6

;Move Bat
MoveBat:
       INC    $CF                 ;Put Bat in the Next State.                    ;5
       LDA    $CF                 ;Get the Bat State.                            ;3
       CMP    #$08                ;Has it Reached the Maximum?                   ;2
       BNE    MoveBat_2                                                          ;2
       LDA    #$00                ;If So, Reset the Bat State.                   ;2
       STA    $CF                                                                ;3

MoveBat_2:
       LDA    $D1                 ;Get the Bat Fed-Up Value.                     ;3
       BEQ    MoveBat_3           ;If Bat Fed-Up then Branch.                    ;2
       INC    $D1                 ;Increment its value for next time.            ;5
       LDA    $CE                 ;Get the Bat's Movement.                       ;3
       LDX    #$CB                ;Position to Bat.                              ;2
       LDY    #$03                ;Get the Bat's Deltas.                         ;2
       JSR    MoveGroundObject    ;Move the Bat.                                 ;6
       JMP    MoveBat_4           ;Update the Bat's Object.                      ;3

;Bat Fed-Up
MoveBat_3:
       LDA    #$CB                ;Store the Bat's Dynamic Data Address          ;2
       STA    $D5                                                                ;3
       LDA    #$03                ;Set the Bat's Delta.                          ;2
       STA    $D4                                                                ;3
       LDA    #<BatMatrix         ;Set the Low Address of Object Store.          ;2
       STA    $D2                                                                ;3
       LDA    #>BatMatrix         ;Set the High Address of Object Store.         ;2
       STA    $D3                                                                ;3
       LDA    $D0                 ;Get Object being Carried by Bat,              ;3
       STA    $D6                 ;      And Copy.                               ;3
       JSR    MoveGameObject      ;Move the Bat.                                 ;6
       LDY    $E1                 ;Get Object Liked Index.                       ;3
       LDA    ($D2),Y             ;Look up the Object Found in the Table.        ;5
       BEQ    MoveBat_4           ;If nothing found then Forget it.              ;2
       INY                                                                       ;2
       LDA    ($D2),Y             ;Get the Object Wanted.                        ;5
       TAX                                                                       ;2
       LDA    VSYNC,X             ;Get the Object's Room.                        ;4
       CMP    $CB                 ;Is it the Same as the Bats?                   ;3
       BNE    MoveBat_4           ;If not Forget it.                             ;2

;See if Bat Can pick up Object.
       LDA    VBLANK,X            ;Get the Object's X Coordinate.                ;4
       SEC                                                                       ;2
       SBC    $CC                 ;Find the differenct with the Bat's            ;3
       CLC                        ;X coordinate.                                 ;2
       ADC    #$04                ;Adjust so Bat in middle of object.            ;2
       AND    #$F8                ;Is Bat within Seven Pixels?                   ;2
       BNE    MoveBat_4           ;If not, no pickup possible.                   ;2
       LDA    WSYNC,X             ;Get the Object's Y Coordinate.                ;4
       SEC                                                                       ;2
       SBC    $CD                 ;Find the Difference with the Bat's            ;3
       CLC                        ;      Y Coordinate.                           ;2
       ADC    #$04                ;Adjust.                                       ;2
       AND    #$F8                ;Is the Bat within Seven Pixels?               ;2
       BNE    MoveBat_4           ;If not, No Pickup Possible.                   ;2

;Get Object
       STX    $D0                 ;Store Object as Being Carried.                ;3
       LDA    #$10                ;Reset the Bat Fed Up Time.                    ;2
       STA    $D1                                                                ;3

;Move Object Being Carried by Bat.
MoveBat_4:
       LDX    $D0                 ;Get Object Being Carried by Bat.              ;3
       LDA    $CB                 ;Get the Bat's Room.                           ;3
       STA    VSYNC,X             ;Store this as the Object's Room.              ;4
       LDA    $CC                 ;Get the Bat's X coordinate.                   ;3
       CLC                                                                       ;2
       ADC    #$08                ;Adjust to the Right.                          ;2
       STA    VBLANK,X            ;Make it the Object's X coordinate.            ;4
       LDA    $CD                 ;Get the Bat's Y Coordinate.                   ;3
       STA    WSYNC,X             ;Store it as the Object's Y Coordinate.        ;4
       LDA    $D0                 ;Get the Object Being Carried by the Bat.      ;3
       LDY    $9D                 ;Get the Object Being Carried by the Ball.     ;3
       CMP    Store1,Y             ;Are the the Same?                            ;4
       BNE    MoveBat_5           ;If not Branch.                                ;2
       LDA    #$90                ;Set Nothing Being    (Num Is (8*NumOfObj)-8)  ;2
       STA    $9D                 ;      Carried.                                ;3
MoveBat_5:
       RTS                                                                       ;6



;Deal with Portcullis and Collisions.
Portals:
       LDY    #$02                ;For Each Portcullis.                          ;2
Portals_2:
       LDX    PortOffsets,Y             ;Get the Portcullises offset number.     ;4
       JSR    FindObjHit          ;See if an Object Collided with it.            ;6
       STA    $97                 ;      Store that Object.                      ;3
       CMP    KeyOffsets,Y             ;Is it the Associated Key?                ;4
       BNE    Portals_3           ;If not then Branch.                           ;2
       TYA                        ;Get the Portcullis Number                     ;2
       TAX                                                                       ;2
       INC    $C8,X               ;Change it's state to open it.                 ;6

Portals_3:
       TYA                        ;Get the Porcullis number.                     ;2
       TAX                                                                       ;2
       LDA    $C8,X               ;Get the State.                                ;4
       CMP    #$1C                ;Is it Closed?                                 ;2
       BEQ    Portals_7           ;Yes - then Branch.                            ;2
       LDA    PortOffsets,Y             ;Get Portcullis number.                  ;4
       JSR    PBCollision         ;Get the Player-Ball Collision.                ;6
       BEQ    Portals_4           ;If Not Then Branch.                           ;2
       LDA    #$01                ;Set the Portcullis to Closed.                 ;2
       STA    $C8,X                                                              ;4
       LDX    #$8A                ;Set to the Castle.                            ;2
       JMP    Portals_6           ;Put the Ball in the Castle.                   ;3

Portals_4:
       LDA    $97                 ;Get the Object that hit the Portcullis.       ;3
       CMP    #$90                ;Is it nothing?  (Num Is (8 * NumOfObj) - 8)   ;2
       BEQ    Portals_5           ;If so, Branch.                                ;2
       LDX    $97                 ;Get Object.                                   ;3
       STY    $9A                 ;Save Y                                        ;3
       JSR    GetObjectAddress    ;And find it's Dynamic Address.                ;6
       LDY    $9A                 ;Retrieve Y                                    ;3
       LDX    $93                 ;Get Object's Address.                         ;3
       JMP    Portals_6           ;Put Object In the Castle.                     ;3

Portals_5:
       JMP    Portals_7                                                          ;3

Portals_6:
       LDA    EntryRoomOffsets,Y ;Look up Castle endry room for this port.       ;4
       STA    VSYNC,X       ;Make it the object's Room.                          ;4
       LDA    #$10          ;Give the Object a new Y coordinate.                 ;2
       STA    WSYNC,X                                                            ;4

Portals_7:
       TYA                  ;Get the Portcullis number.                          ;2
       TAX                                                                       ;2
       LDA    $C8,X         ;Get its State.                                      ;4
       CMP    #$01          ;Is it Open?                                         ;2
       BEQ    Portals_8     ;Yes - Then Branch.                                  ;2
       CMP    #$1C          ;Is it Closed?                                       ;2
       BEQ    Portals_8     ;Yes - Then Branch.                                  ;2
       INC    $C8,X         ;Increment it's State.                               ;6
       LDA    $C8,X         ;Get the State.                                      ;4
       CMP    #$38          ;Has it reached the maximum state.                   ;2
       BNE    Portals_8     ;If not, Branch.                                     ;2
       LDA    #$01          ;Set to Closed                                       ;2
       STA    $C8,X         ;      State.                                        ;4

Portals_8:
       DEY                  ;Goto the next portcullis.                           ;2
       BMI    Portals_9     ;Branch if Finished.                                 ;2
       JMP    Portals_2     ;Do next Protcullis.                                 ;3
  IF ORIGINAL
Portals_9:
       RTS                                                                       ;6
  ENDIF




;Deal With Magnet.
Mag_1:
       LDA    $B5                 ;Get Magnet's Y Coordinate.                    ;3
       SEC                                                                       ;2
       SBC    #$08                ;Adjust to it's "Poles".                       ;2
       STA    $B5                                                                ;3
       LDA    #$00                ;Con Difficulty!                               ;2
       STA    $D6                                                                ;3
       LDA    #<MagnetMatrix                ;Set Low Address of Object Store.    ;2
       STA    $D2                                                                ;3
       LDA    #>MagnetMatrix                ;Set High Address of Object Store.   ;2
       STA    $D3                                                                ;3
       JSR    GetLinkedObject     ;Get Liked Object and Set Movement.            ;6
       LDA    $9B                 ;Get Movement.                                 ;3
       BEQ    Mag_2               ;If None, then Forget It.                      ;2
       LDY    #$01                ;Set Delta to One.                             ;2
       JSR    MoveGroundObject     ;Move Object.                                 ;6

Mag_2:
     LDA    $B5                 ;Reset the Magnet's                              ;3
       CLC                        ;      Y Coordinate.                           ;2
       ADC    #$08                                                               ;2
       STA    $B5                                                                ;3

  IF ORIGINAL = 0
Portals_9:
  ENDIF

       RTS                                                                       ;6


;Deal with Invisible Surround Moving.
Surround:
       LDA    $8A                 ;Get the Current Room.                         ;3
       JSR    RoomNumToAddress    ;Convert it to an Address.                     ;6
       LDY    #$02                                                               ;2
       LDA    ($93),Y             ;Get the Room's Color.                         ;5
       CMP    #$08                ;Is it Invisible?                              ;2
       BEQ    Surround_2          ;If So Branch.                                 ;2
       LDA    #$00                ;If not, signal the                            ;2
       STA    $DB                 ;      Invisible surround not                  ;3
       JMP    Surround_4          ;      Wanted.                                 ;3

Surround_2:
       LDA    $8A                 ;Get the Current Room.                         ;3
       STA    $D9                 ;And store as the Invisible Surrounds.         ;3
       LDA    $8B                 ;Get the Ball's X Coordinate.                  ;3
       SEC                                                                       ;2
       SBC    #$0E                ;Adjust for Surround,                          ;2
       STA    $DA                 ;      and store as surround's X coordinate.   ;3
       LDA    $8C                 ;Get the Ball's Y Coordinate.                  ;3
       CLC                                                                       ;2
       ADC    #$0E                ;Adjust for Surround.                          ;2
       STA    $DB                 ;      and store as surround's Y coordinate.   ;3
       LDA    $DA                 ;Get the Surround's X cordinate.               ;3
       CMP    #$F0                ;Is it close to the right edge?                ;2
       BCC    Surround_3          ;Branch if not.                                ;2
       LDA    #$01                ;Flick surround to the                         ;2
       STA    $DA                 ;      otherside of the screen.                ;3
       JMP    Surround_4                                                         ;3

Surround_3:
       CMP    #$82                ;???                                           ;2
       BCC    Surround_4          ;???                                           ;2

       LDA    #$81                ;???                                           ;2
       STA    $DA                 ;???                                           ;3
Surround_4:
       RTS                                                                       ;6


;Make A Noise.
MakeSound:
       LDA    $DF                 ;Check Not Count.                              ;3
       BNE    MakeSound_2         ;Branch if Noise to be made.                   ;2
       STA    AUDV0               ;Turn off the Volume.                          ;3
       STA    AUDV1                                                              ;3
       RTS                                                                       ;6

MakeSound_2:
       DEC    $DF                 ;Goto the Next Note.                           ;5

  IF ORIGINAL
       LDA    $E0                 ;Get the Noise Type.                           ;3
       BEQ    NoiseGameOver       ;Game Over                                     ;2
       CMP    #$01                ;Roar                                          ;2
       BEQ    NoiseRoar                                                          ;2
       CMP    #$02                ;Man Eaten.                                    ;2
       BEQ    EatenNoise                                                         ;2
       CMP    #$03                ;Dying Dragon.                                 ;2
       BEQ    DragDieNoise                                                       ;2
       CMP    #$04                ;Dropping Object.                              ;2
       BEQ    NoiseDropObject                                                    ;2
       CMP    #$05                ;Picking up Object.                            ;2
       BEQ    NoiseGetObject                                                     ;2
  ELSE
; instead of comparing with A, we use X:
       LDX    $E0                 ;Get the Noise Type.                           ;3
       BEQ    NoiseGameOver       ;Game Over                                     ;2
       DEX                        ;Roar                                          ;2
       BEQ    NoiseRoar                                                          ;2
       DEX                        ;Man Eaten.                                    ;2
       BEQ    EatenNoise                                                         ;2
       DEX                        ;Dying Dragon.                                 ;2
       BEQ    DragDieNoise                                                       ;2
       DEX                        ;Dropping Object.                              ;2
       BEQ    NoiseDropObject                                                    ;2
       DEX                        ;Picking up Object.                            ;2
       BEQ    NoiseGetObject                                                     ;2
; 5 bytes saved
  ENDIF

       RTS                                                                       ;6


;Noise 0 : Game Over
NoiseGameOver:
       LDA    $DF                                                                ;3
       STA    COLUPF              ;Color-Luminance Playfield.                    ;3
       STA    AUDC0               ;Audio-Control 00                              ;3
       LSR                                                                       ;2
       STA    AUDV0               ;Audio-Volume 00                               ;3
       LSR                                                                       ;2
       LSR                                                                       ;2
       STA    AUDF0               ;Audio-Frequency 00                            ;3
       RTS                                                                       ;6

;Noise 1 : Roar
NoiseRoar:
       LDA    $DF                 ;Get noise count.                              ;3
       LSR                                                                       ;2
       LDA    #$03                ;If it was even then                           ;2
       BCS    SetVolume           ;Branch.                                       ;2
       LDA    #$08                ;Get a differnt audio control value.           ;2

SetVolume:
       STA    AUDC0               ;Set Audio Control 00.                         ;3
       LDA    $DF                 ;Set the Volume to the Noise Count.            ;3
       STA    AUDV0                                                              ;3
       LSR                        ;Divide by Four.                               ;2
       LSR                                                                       ;2
       CLC                                                                       ;2
       ADC    #$1C                ;Set the Frequency.                            ;2
       STA    AUDF0                                                              ;3
       RTS                                                                       ;6


;Noise 2 : Man Eaten
EatenNoise:
       LDA    #$06                                                               ;2
       STA    AUDC0               ;Audio-Control 00                              ;3
       LDA    $DF                                                                ;3
       EOR    #$0F                                                               ;2
       STA    AUDF0               ;Audio-Frequency 00                            ;3
       LDA    $DF                                                                ;3
       LSR                                                                       ;2
       CLC                                                                       ;2
       ADC    #$08                                                               ;2
       STA    AUDV0               ;Audio-Volume 00                               ;3
       RTS                                                                       ;6


;Noise 3 : Dyning Dragon
DragDieNoise:
       LDA    #$04                ;Set the Audio Control                         ;2
       STA    AUDC0                                                              ;3
       LDA    $DF                 ;Put the Note Count In                         ;3
       STA    AUDV0               ;      the Volume.                             ;3
       EOR    #$1F                                                               ;2
       STA    AUDF0               ;Flip the Count as store                       ;3
       RTS                        ;      as the frequency.                       ;6


;Noise 4 : Dropping Object.
NoiseDropObject:
       LDA    $DF                 ;Get Not Count                                 ;3
       EOR    #$03                ;Reverse it as noise does up.                  ;2
NoiseDropObject_2:
       STA    AUDF0               ;Store in Frequency for Channel 00.            ;3

  IF ORIGINAL
       LDA    #$05                                                               ;2
       STA    AUDV0               ;Set Volume on Channel 00.                     ;3
       LDA    #$06                                                               ;2
       STA    AUDC0               ;Set a Noise on Channel 00.                    ;3
  ELSE
       LDX    #$05                                                               ;2
       STX    AUDV0               ;Set Volume on Channel 00.                     ;3
       INX                                                                       ;2
       STX    AUDC0               ;Set a Noise on Channel 00.                    ;3
;Use an unused register instead...1 byte saved
  ENDIF

       RTS                                                                       ;6


;Noise 5 : Picking up an Object.
NoiseGetObject:
       LDA    $DF                 ;Get Not Count.                                ;3
       JMP    NoiseDropObject_2   ;      and Make Same noise as Drop.            ;3


;all "curr" constants put on the same byte location (all just a single $00 value)
SwordCurr:
DotCurr:
SurroundCurr:
BridgeCurr:
KeyCurr:
ChalliseCurr:
AuthorCurr:
NullCurr:
MagnetCurr:
NumberInfo:
       .byte $00,$50,$40          ;#5 Number: Room 00, (50,40)

;Object #11 : List of States
MagnetStates:
       .byte $FF,<GfxMagnet,>GfxMagnet          ;State FF at FE12


;Object #10 : List of States
ChalliseStates:
       .byte $FF,<GfxChallise,>GfxChallise          ;State FF at &FDF3


;Object #1 States (Portcullis)
PortStates:
       .byte $04,<GfxPort07,>GfxPort07          ;State 04 at FB24 -Open
       .byte $08,<GfxPort06,>GfxPort06          ;State 08 at FB22
       .byte $0C,<GfxPort05,>GfxPort05          ;State 0C at FB20
       .byte $10,<GfxPort04,>GfxPort04          ;State 10 at FB1E
       .byte $14,<GfxPort03,>GfxPort03          ;State 14 at FB1C
       .byte $18,<GfxPort02,>GfxPort02          ;State 18 at FB1A
LFB03: .byte $1C,<GfxPort01,>GfxPort01          ;State 1C at FB18 -Closed
       .byte $20,<GfxPort02,>GfxPort02          ;State 20 at FB1A
       .byte $24,<GfxPort03,>GfxPort03          ;State 24 at FB1C
       .byte $28,<GfxPort04,>GfxPort04          ;State 28 at FB1E
       .byte $2C,<GfxPort05,>GfxPort05          ;State 2C at FB20
       .byte $30,<GfxPort06,>GfxPort06          ;State 30 at FB22
LFB15: .byte $FF,<GfxPort07,>GfxPort07          ;State FF at FB24 -Open



;Object Data
;Offset 0 : Room number of object.
;Offset 1 : X Coordinate of object.
;Offset 2 : Y Coordinate of object.

;Object #1 : Portcullis
PortInfo1:
       .byte $11,$4D,$31          ;Room 11, (4D, 31)
;Object #2 : Portcullis
PortInfo2:
       .byte $0F,$4D,$31          ;Room 0F, (4D, 31)
;Object #3 : Portcullis
PortInfo3:
       .byte $10,$4D,$31          ;Room 10, (4D, 31

;Object #1 : State List
SurroundStates:
       .byte $FF,<GfxSurround,>GfxSurround          ;State FF as FC05

;Object #0A : List of States
BridgeStates:
       .byte $FF,<GfxBridge,>GfxBridge          ;State FF at &FCDB


;Object #0B : List of States
KeyStates:
       .byte $FF,<GfxKey,>GfxKey


;Object #0E : List of States
BatStates:
       .byte $03,<GfxBat1,>GfxBat1          ;State 03 at &FD1A
LFD17: .byte $FF,<GfxBat2,>GfxBat2          ;State FF as &FD22

;Object #6 : States
DragonStates:
       .byte $00,<GfxDrag0,>GfxDrag0          ;State 00 at &FD3A
LFD31: .byte $01,<GfxDrag2,>GfxDrag2          ;State 01 at &FD66
LFD34: .byte $02,<GfxDrag0,>GfxDrag0          ;State 02 at &FD3A
LFD37: .byte $FF,<GfxDrag1,>GfxDrag1          ;State FF at &FD4F



;Object #9 : List of States
SwordStates:
       .byte $FF,<GfxSword,>GfxSword          ;State FF at &FD7C


;Object #0F : List of States
DotStates:
       .byte $FF,<GfxDot,>GfxDot          ;State FF at FD86


;Object $4 : Author's Name
AuthorInfo:
       .byte $1E,$50,$69          ;Room 1E, (50, 69)

;Object #5 States.
NumberStates:
       .byte $01,<GfxNum1,>GfxNum1          ;State 1 as FCF4
LFE08: .byte $03,<GfxNum2,>GfxNum2          ;State 3 as FD04
LFE0B: .byte $FF,<GfxNum3,>GfxNum3          ;State FF as FD0C


;Object #12 : List of States
NullStates:
       .byte $FF,<GfxNull,>GfxNull

;Objects
;Offset 0 : Low byte object information (moveable stuff)
;Offset 1 : High byte object information (moveable stuff)
;Offset 2 : Low byte to object's current state
;Offset 3 : High byte to object's current state
;Offset 4 : Low byte list of states
;Offset 5 : High byte list of states
;Offset 6 : Colour
;Offset 7 : Colour in B&W.
;Offset 8 : Size of object

Store1:
       .byte $D9                        ;0      ;#0 Invisible Surround Offsets..      00
Store2:
       .byte $00                        ;1
Store3:
       .byte <SurroundCurr              ;2
Store4:
       .byte >SurroundCurr              ;3
Store5:
       .byte <SurroundStates            ;4
Store6:
       .byte >SurroundStates            ;5
Store7:
       .byte $28                        ;6
Store8:
       .byte $07                        ;7

       .byte <PortInfo1,>PortInfo1,$C8,$00,<PortStates,>PortStates,$00,$00 ;#1 Portcullis #1
       .byte <PortInfo2,>PortInfo2,$C9,$00,<PortStates,>PortStates,$00,$00 ;#2 Portcullis #2
       .byte <PortInfo3,>PortInfo3,$CA,$00,<PortStates,>PortStates,$00,$00 ;#3 Portcullis #3
       .byte <AuthorInfo,>AuthorInfo,<AuthorCurr,>AuthorCurr,<AuthorStates,>AuthorStates,$CB,$00 ;#4 Name Flash  24 (20)
       .byte <NumberInfo,>NumberInfo,$DD,$00,<NumberStates,>NumberStates,$C8,$00 ;#5 Number
       .byte $A4,$00,$A8,$00,<DragonStates,>DragonStates,$36,$00 ;#6 Dragon #1 Red 36  (30)
       .byte $A9,$00,$AD,$00,<DragonStates,>DragonStates,$1A,$00 ;#7 Dragon #2 Yellow 3F  (38)
       .byte $AE,$00,$B2,$00,<DragonStates,>DragonStates,$C8,$00 ;#8 Dragon #3  Green 48  (40)
       .byte $B6,$00,<SwordCurr,>SwordCurr,<SwordStates,>SwordStates,$1A,$00 ;#9 Sword Yellow
       .byte $BC,$00,<BridgeCurr,>BridgeCurr,<BridgeStates,>BridgeStates,$66,$07 ;#0A Bridge
       .byte $BF,$00,<KeyCurr,>KeyCurr,<KeyStates,>KeyStates,$1A,$00 ;#0B Key #01 Yellow 63(58)
       .byte $C2,$00,<KeyCurr,>KeyCurr,<KeyStates,>KeyStates,$0E,$00 ;#0C Key #02 White 6C (60)
       .byte $C5,$00,<KeyCurr,>KeyCurr,<KeyStates,>KeyStates,$00,$00 ;#0D Key #03 Black 75(68)
       .byte $CB,$00,$CF,$00,<BatStates,>BatStates,$00,$00 ;#0E Bat Black 7E (70)
       .byte $A1,$00,<DotCurr,>DotCurr,<DotStates,>DotStates,$08,$00 ;#0F Black Dot Light Gray
       .byte $B9,$00,<ChalliseCurr,>ChalliseCurr,<ChalliseStates,>ChalliseStates,$CB,$00 ;cup
       .byte $B3,$00,<MagnetCurr,>MagnetCurr,<MagnetStates,>MagnetStates,$00,$00 ;#11 Magnet
       .byte $BC,$00,<NullCurr,>NullCurr,<NullStates,>NullStates,$00,$00 ;#12 Null Black A2(90)



;Room differences for different levels (level 1,2,3)
RoomDiffs:
       .byte $10,$0F,$0F            ;Down from Room 01
       .byte $05,$11,$11            ;Down from Room 02
       .byte $1D,$0A,$0A            ;Down from Room 03
       .byte $1C,$16,$16            ;U/L/R/D from Room 1B (Black Castle Room)
       .byte $1B,$0C,$0C            ;Down from Room 1C
       .byte $03,$0C,$0C            ;Up from Room 1D (Top Entry Room)


;Room Bounds Data.
;Ex. the chalise at location &B9 can only exist in rooms 13-1A for
;     level 3.
Loc_1:
       .byte $B9                    ;
Loc_2:
       .byte $13                    ;Chalise
Loc_3:
       .byte $1A                    ;
       .byte $A4,$01,$1D            ;Red Dragon
       .byte $A9,$01,$1D            ;Yellow Dragon
       .byte $AE,$01,$1D            ;Green Dragon
       .byte $B6,$01,$1D            ;Sword
       .byte $BC,$01,$1D            ;Bridge
       .byte $BF,$01,$1D            ;Yellow Key
       .byte $C2,$01,$16            ;White Key
       .byte $C5,$01,$12            ;Black Key
       .byte $CB,$01,$1D            ;Bat
       .byte $B3,$01,$1D            ;Magnet

Loc_4:
       .byte <Game1Objects                    ;Pointer to object locations for game 01.
Loc_5:
       .byte >Game1Objects                    ;      --continued.
       .byte <Game2Objects,>Game2Objects      ;Pointer to object locations for game 02.
       .byte <Game2Objects,>Game2Objects      ;Pointer to object locations for game 03.



;Bat Object Matrix.
BatMatrix:
       .byte $CB,$B9                  ;Bat,Chalise
       .byte $CB,$B6                  ;Bat,Sword
       .byte $CB,$BC                  ;Bat,Bridge
       .byte $CB,$BF                  ;Bat,Yellow Key
       .byte $CB,$C2                  ;Bat,White Key
       .byte $CB,$C5                  ;Bat,Black Key
       .byte $CB,$A4                  ;Bat,Red Dragon
       .byte $CB,$A9                  ;Bat,Yellow Dragon
       .byte $CB,$AE                  ;Bat,Green Dragon
       .byte $CB,$B3                  ;Bat,Magnet
       .byte $00


       ORG $FDFE


;Dragon Difficulty
DragonDiff:
       .byte $D0,$E8                  ;Level 1 : Am, Pro
       .byte $F0,$F6                  ;Level 2 : Am, Pro
       .byte $F0,$F6                  ;Level 3 : Am, Pro

;Object locations (room and coordinate) for game 01.
Game1Objects:
       .byte $15,$51,$12            ;Black dot (Room, X, Y)
       .byte $0E,$50,$20,$00,$00    ;Red Dragon (Room, X, Y, Movement, State)
       .byte $01,$50,$20,$00,$00    ;Yellow Dragon (Room, X, Y, Movement, State)
       .byte $1D,$50,$20,$00,$00    ;Green Dragon (Room, X, Y, Movement, State)
       .byte $1B,$80,$20            ;Magnet (Room,X,Y)
       .byte $12,$20,$20            ;Sword (Room,X,Y)
       .byte $1C,$30,$20            ;Challise (Room,X,Y)
       .byte $04,$29,$37            ;Bridge (Room,X,Y)
       .byte $11,$20,$40            ;Yellow Key (Room,X,Y)
       .byte $0E,$20,$40            ;White Key (Room,X,Y)
       .byte $1D,$20,$40            ;Black Key (Room,X,Y)
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $1A,$20,$20,$00,$00    ;Bat (Room, X, Y, Movement, State)
       .byte $78,$00                ;Bat (Carrying, Fed-Up)

;Object locations (room and coordinate) for Games 02 and 03.
Game2Objects:
       .byte $15,$51,$12            ;Black Dot (Room,X,Y)
       .byte $14,$50,$20,$A0,$00    ;Red Dragon (Room,X,Y,Movement,State)
       .byte $19,$50,$20,$A0,$00    ;Yellow Dragon (Room,X,Y,Movement,State)
       .byte $04,$50,$20,$A0,$00    ;Green Dragon (Room,X,Y,Movement,State)
       .byte $0E,$80,$20            ;Magnet (Room,X,Y)
       .byte $11,$20,$20            ;Sword (Room,X,Y)
       .byte $14,$30,$20            ;Chalise (Room,X,Y)
       .byte $0B,$40,$40            ;Bridge (Room,X,Y)
       .byte $09,$20,$40            ;Yellow Key (Room,X,Y)
       .byte $06,$20,$40            ;White Key (Room,X,Y)
       .byte $19,$20,$40            ;Black Key (Room,X,Y)
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $02,$20,$20,$90,$00    ;Bat (Room,X,Y,Movement,State)
       .byte $78,$00                ;Bat (Carrying, Fed-Up)


;Magnet Object Matrix.
MagnetMatrix:
       .byte $BF,$B3                  ;Yellow Key, Magnet
       .byte $C2,$B3                  ;White Key, Magnet
       .byte $C5,$B3                  ;Black Key, Magnet
       .byte $B6,$B3                  ;Sword, Magnet
       .byte $BC,$B3                  ;Bridge, Magnet
       .byte $B9,$B3                  ;Chalise, Magnet
       .byte $00

;Object #4 : States
AuthorStates:
       .byte $FF,<GfxAuthor,>GfxAuthor          ;State FF at &FD88

;Portcullis #1, #2, #3
PortOffsets:
     .byte $08,$10,$18

;Keys #1, #2, #3  (Yellow, White, Black)
KeyOffsets:
     .byte $58,$60,$68

;Castle Entry Rooms (Yellow, White, Black)
EntryRoomOffsets:
     .byte $12,$1A,$1B

;Castle Rooms (Yellow, White, Black)
CastleRoomOffsets:
     .byte $11,$0F,$10

;Room Data
;Offset 0 : Low byte foom graphics data.
;Offset 1 : High byte room graphics data
;Offset 2 : Color
;Offset 3 : Bits 5-0 : Playfield Control
;            Bit 6 : True if right thin wall wanted.
;            Bit 7 : True if left thin wall wanted.
;Offset 4 : Room Above
;Offset 5 : Room Left
;Offset 6 : Room Down
;Offset 7 : Room Right
RoomDataTable:
       .byte <NumberRoom,>NumberRoom,                $66,$21,$00,$00,$00,$00      ;00
       .byte <BelowYellowCastle,>BelowYellowCastle,  $D8,$A1,$08,$02,$80,$03      ;01
       .byte <BelowYellowCastle2,>BelowYellowCastle2,$C8,$21,$11,$03,$83,$01      ;02 2
       .byte <LeftOfName,>LeftOfName,                $E8,$61,$06,$01,$86,$02      ;03
       .byte <BlueMazeTop,>BlueMazeTop,              $86,$21,$10,$05,$07,$06      ;04
       .byte <BlueMaze1,>BlueMaze1,                  $86,$21,$1D,$06,$08,$04      ;05
       .byte <BlueMazeBottom,>BlueMazeBottom,        $86,$21,$07,$04,$03,$05      ;06
       .byte <BlueMazeCenter,>BlueMazeCenter,        $86,$21,$04,$08,$06,$08      ;07
       .byte <BlueMazeEntry,>BlueMazeEntry,          $86,$21,$05,$07,$01,$07      ;08
       .byte <MazeMiddle,>MazeMiddle,                $08,$25,$0A,$0A,$0B,$0A      ;09
       .byte <MazeEntry,>MazeEntry,                  $08,$25,$03,$09,$09,$09      ;0A
       .byte <MazeSide,>MazeSide,                    $08,$25,$09,$0C,$1C,$0D      ;0B
       .byte <SideCorridor,>SideCorridor,            $98,$61,$1C,$0D,$1D,$0B      ;0C
       .byte <SideCorridor2,>SideCorridor2,          $B8,$A1,$0F,$0B,$0E,$0C      ;0D 2
       .byte <TopEntryRoom,>TopEntryRoom,            $A8,$21,$0D,$10,$0F,$10      ;0E
       .byte <CastleDef,>CastleDef,                  $0C,$21,$0E,$0F,$0D,$0F      ;0F -
       .byte <CastleDef,>CastleDef,                  $00,$21,$01,$1C,$04,$1C      ;10 -
       .byte <CastleDef,>CastleDef,                  $1A,$21,$06,$03,$02,$01      ;11 -
       .byte <NumberRoom2,>NumberRoom2,              $1A,$21,$12,$12,$12,$12      ;12 2
       .byte <BlackMaze1,>BlackMaze1,                $08,$25,$15,$14,$15,$16      ;13
       .byte <BlackMaze2,>BlackMaze2,                $08,$24,$16,$15,$16,$13      ;14
       .byte <BlackMaze3,>BlackMaze3,                $08,$24,$13,$16,$13,$14      ;15
       .byte <BlackMazeEntry,>BlackMazeEntry,        $08,$25,$14,$13,$1B,$15      ;16
       .byte <RedMaze1,>RedMaze1,                    $36,$21,$19,$18,$19,$18      ;17
       .byte <RedMazeTop,>RedMazeTop,                $36,$21,$1A,$17,$1A,$17      ;18
       .byte <RedMazeBottom,>RedMazeBottom,          $36,$21,$17,$1A,$17,$1A      ;19
       .byte <WhiteCastleEntry,>WhiteCastleEntry,    $36,$21,$18,$19,$18,$19      ;1A
       .byte <TwoExitRoom,>TwoExitRoom,              $36,$21,$89,$89,$89,$89      ;1B
       .byte <NumberRoom3,>NumberRoom3,              $66,$21,$1D,$07,$8C,$08      ;1C 3
       .byte <TopEntryRoom2,>TopEntryRoom2,          $36,$21,$8F,$01,$10,$03      ;1D 2
       .byte <BelowYellowCastle3,>BelowYellowCastle3,$66,$21,$06,$01,$06,$03      ;1E 3
       .byte <CustomRoom1,>CustomRoom1,              $66,$21,$00,$00,$00,$00      ;1F
       .byte <CustomRoom2,>CustomRoom2,              $66,$21,$00,$00,$00,$00      ;20
       .byte <CustomRoom3,>CustomRoom3,              $66,$21,$00,$00,$00,$00      ;21
       .byte <CustomRoom4,>CustomRoom4,              $66,$21,$00,$00,$00,$00      ;22
       .byte <CustomRoom5,>CustomRoom5,              $66,$21,$00,$00,$00,$00      ;23
       .byte <NumberRoom,>NumberRoom,                $66,$21,$00,$00,$00,$00      ;24

;all must be on 1 page
;Red Dragon Object Matrix
RedDragMatrix:
       .byte $B6,$A4                  ;Sword, Red Dragon
       .byte $A4,$8A                  ;Red Dragon, Ball
       .byte $A4,$B9                  ;Red Dragon, Chalise
       .byte $A4,$C2                  ;Red Dragon, White Key
       .byte $00
       .byte $00
       .byte $00
       .byte $00
       .byte $00
;Yellow Dragon's Object Matrix
YelDragMatrix:
       .byte $B6,$A9                  ;Sword, Yellow Dragon
       .byte $BF,$A9                  ;Yellow Key, Yellow Dragon
       .byte $A9,$8A                  ;Yellow Dragon, Ball
       .byte $A9,$B9                  ;Yellow Dragon, Chalise
       .byte $00
       .byte $00
       .byte $00
       .byte $00
       .byte $00
;Green Dragon's Object Matrix
GreenDragonMatrix:
       .byte $B6,$AE                  ;Sword, Green Dragon
       .byte $AE,$8A                  ;Green Dragon, Ball
       .byte $AE,$B9                  ;Green Dragon Chalise
       .byte $AE,$BC                  ;Green Dragon, Bridge
       .byte $AE,$B3                  ;Green Dragon, Magnet
       .byte $AE,$C5                  ;Green Dragon, Black Key
       .byte $00


  ORG $fff8
;do not use $fff8/$fff9...bankswitch rom locations
        .byte $FF,$FF

;6502 Vectors (Not Used??
LFFFA:  .byte $00,$F0
LFFFC:  .word StartGame
LFFFE:  .byte $00,$F0

